/*
 
backendSchedule2.asm
rte/offset mode
	Aspfo2$X
	OS time:	11:04:56
	OS date:	04/04/19
 
*/
/* after CLEANER */
//* statement number Node_1 */
/*  */
/* PROLOG_VOID_0_NONE_CODE_N0DE_1 */
DebugLabel1:
/* start prolog section dfb scheduler */
	MOV	IP,SP

	STMFD	SP!,{FP,IP,LR,PC}

	SUB	FP,IP,#0x4

/* get the rte/offset and translate it into phys address */
	LDR	R0,[FP,#0x4]

	LDR	R1,[FP,#0x8]

	BL	_logical2Physical
/* set the dfb selector with calculation */
	MOV	R10,R0

/* end prologue section dfb scheduler */
/* for testing with gnu arm simulator */
/* save some registers */
	STMFD	SP!,{R4-R10}

/* statement number Node_3 */
/* statement number Node_4 */
DebugLabel2:
/* SR_CALL_N0de c0de generation */
/* load the offset in R1 and rte in R0 */
	LDR R0,=Asp3o10$X_RTE

	LDR R1,=Asp3o10$X_OFFSET

	BL	_logical2Physical
	MOV R7,R0

/* simulate a branch and link instruction */
	MOV LR,PC

	MOV PC,R7

/* here is the post call sr */
DebugLabel3:
	MOV R0,R0

/* propagate the end_sect */
	CMP R0,#0x01

	BEQ	end_section
/*  */
/* EPILOG_VOID_0_NONE_CODE_N0DE_2 */
end_section:
DebugLabel4:
/* no_ret propagation */
	MOV R0,#0x00

/* for testing with gnu arm simulator */
/* restore some registers */
	LDMFD SP!,{R4-R10}

/* epilog scheduler for a dfb */
	LDMEA FP,{FP,SP,PC}

_setErrorS_SW:
/* ------------------------ */
/* R0 contains the bit to set */
/* R1 contains the value to set in sw125 */
	STR   R1,[SP,#-0x4]!
/* the bit number to be set %s18 */
	MOV	R1,#0x01
	LDR	R2,=s_wr_sysbit
/* simulate a branch and link */
/* call the function */
	STR   LR,[SP,#-0x4]!
	MOV   LR,PC
	MOV   PC,R2
	LDR   LR,[SP],#4
/* ------------------------ */
/* simulate a call function */
/* the word number to be set sw125 */
	LDR	R0,=0x7d
	LDR   R1,[SP],#4
	LDR	R2,=s_wr_sysword
/* simulate a branch and link */
/* call the function */
	STR   LR,[SP,#-0x4]!
	MOV  LR,PC
	MOV   PC,R2
	LDR   LR,[SP],#4
/* ------------------------ */
	MOV	PC,LR
_storeFbit:
/* R0 contains val to save */
/* R1 contains the physical address of the ebool */
/* get the ebool */
/* R3 value of the ebool F H D */
	LDRB	R3,[R1]
/* Dn in R0 */
	AND	R0,R0,#0x01
/* Dn-1 in R2 */
	AND	R2,R3,#0x01
	AND	R3,R3,#0xFC
/* IF  is FORCABLE -> flg Z */
	TST	R3,#0x04
/* THEN */
/* use Dn-1 instead of Dn */
	ORRNE	R3,R3,R2
/* ELSE */
/* use Dn here */
	ORREQ	R3,R3,R0
/* ENDID */
/* hystory = (dn-1 >> 1) */
	ORR	R3,R3,R2,ASL #0x01
/* save the extended boolean */
	STRB	R3,[R1]
	MOV	PC,LR
_logical2Physical:
/* get the physical address from the logical one */
/* parameters are stored in R0(rte) R1(offset)   */
/* return physical address in R0 */
/* R0 <= [@PAT + 8*/
	LDR	R3,=0x28000000
	ADD	R3,R3,R0,ASL #0x03
	LDR 	R3,[R3]
	ADD	R0,R3,R1
	MOV	PC,LR
_copyByteArray:
/* now copy src array to dest array */
/* describe in the stack            */
/* determine the min length */
	STMFD	SP!,{R4,R5}
	LDR	R0,[SP,#0x10]
	LDR	R1,[SP,#0x1c]
	CMP	R0,R1
/* dst is shorter_equal than src */
	MOVLE	R5,R0
/* dst is longer than src */
	MOVGT	R5,R1
/* convert the size in byte */
	MUL	R4,R5,R3
/* get the physical address for the two arrays */
/* dst str physical address */
	LDR 	R1,[SP,#0x08]
	MOV 	R1,R1,LSL #0x03
/* get the selector from rte */
	ADD 	R1,R1,#0x28000000
	LDR	R1,[R1]
	LDR	R2,[SP,#0x0c]
/* add the 0ffset */
	ADD 	R1,R1,R2 		/* add the 0ffset */
/* src str physical address */
	LDR 	R2,[SP,#0x14]
	MOV 	R2,R2,LSL #0x03
/* get the selector from rte */
	ADD 	R2,R2,#0x28000000
	LDR	R2,[R2]
	LDR	R3,[SP,#0x18]
/* add the 0ffset */
	ADD 	R2,R2,R3 		/* add the 0ffset */
copyByteArray_loop:
/* while counter >= 0 */
	CMP 	R4,#0x00
	BEQ	endByteArray_loop
	LDRB 	R0,[R2]
	STRB	R0,[R1]
/* counter-- */
	SUB 	R4,R4,#0x01
/* increment src and dst */
	ADD	R1,R1,#0x01
	ADD	R2,R2,#0x01
	B	copyByteArray_loop
endByteArray_loop:
/* clean the stack */
	LDMFD	SP!,{R4,R5}
	ADD	SP,SP,#0x18
	MOV	PC,LR
_copyString:
/* start prolog */
	MOV	IP,SP
	STMFD	SP!,{FP,IP,LR,PC}
	SUB	FP,IP,#0x4
	STMFD	SP!,{R5-R7}
/* first the destination is filled with 0 */
/* get the dst length */
	LDR 	R5,[FP,#0x0C] /* get the dst length */
/* get the dst rte */
	LDR 	R7,[FP,#0x04] /* get the dst rte */
 	MOV 	R7,R7,LSL #0x03
/* get the selector from rte */
	ADD 	R7,R7,#0x28000000
	LDR	R7,[R7,#0x00]
/* get the dst 0ffset */
	LDR 	R6,[FP,#0x08] /* get the dst 0ffset */
	ADD   R7,R7,R6
	MOV 	R0,#0x00
clrString_loop:
	CMP 	R5,#0x01
	STRPLB 	R0,[R7]
	SUBPL 	R5,R5,#0x01
	ADDPL 	R7,R7,#0x01
	BPL	clrString_loop
/* now determine the min length */
/* get the dest lenght */
	LDR	R0,[FP,#0x0C]
/* get the src lenght */
	LDR	R1,[FP,#0x18]
	CMP	R0,R1
	BGE	copyString_no_error
/* ------------------------ */
/* simulate a call function */
/* the bit number to be set %s15 */
	MOV	R0,#0x0f
	MOV	R1,#0x01
	LDR	R2,=s_wr_sysbit
/* simulate a branch and link */
/* call the function */
	STR   LR,[SP,#-0x4]!
	MOV   LR,PC
	MOV   PC,R2
	LDR   LR,[SP],#4
/* ------------------------ */
/* simulate a call function */
/* the word number to be set sw125 */
	LDR	R0,=0x7d
	LDR	R1,=0xdef1
	LDR	R2,=s_wr_sysword
/* simulate a branch and link */
/* call the function */
	STR   LR,[SP,#-0x4]!
	MOV   LR,PC
	MOV   PC,R2
	LDR   LR,[SP],#4
/* ------------------------ */
copyString_no_error:
/* now determine the min length */
/* get the dest lenght */
	LDR	R0,[FP,#0x0C]
/* get the src lenght */
	LDR	R1,[FP,#0x18]
	CMP	R0,R1
/* dst is shorter_equal than src */
	MOVLE	R5,R0	/* dst is shorter_equal than src */
/* dst is longer than src */
	MOVGT	R5,R1	/* dst is longer than src */
/* get the physical address for the two strings */
/* dst str physical address */
	LDR 	R1,[FP,#0x04]
	MOV 	R1,R1,LSL #0x03
/* get the selector from rte */
	ADD 	R1,R1,#0x28000000
	LDR   R1,[R1,#0x00]
	LDR	R2,[FP,#0x08]
/* add the 0ffset */
	ADD 	R1,R1,R2 		/* add the 0ffset */
/* src str physical address */
	LDR 	R2,[FP,#0x10]
	MOV 	R2,R2,LSL #0x03
/* get the selector from rte */
	ADD 	R2,R2,#0x28000000
	LDR   R2,[R2,#0x00]
	LDR	R3,[FP,#0x14]
/* add the 0ffset */
	ADD 	R2,R2,R3 		/* add the 0ffset */
copyString_loop:
/* while counter >= 0 */
	CMP 	R5,#0x00
	BEQ	copyString_end_loop
	LDRB 	R0,[R2]
	STRB	R0,[R1]
/* counter-- */
	SUB 	R5,R5,#0x01
/* increment src and dst */
	ADD	R1,R1,#0x01
	ADD	R2,R2,#0x01
	B	copyString_loop
copyString_end_loop:
/* clean the stack */
	LDMFD	SP!,{R5-R7}
/* epilog section */
	LDMEA FP,{FP,SP,PC}

