/*
////////////////////////////
backendResu.asm
rte/offset mode
	OS time:	16:24:19
	OS date:	04/11/19
////////////////////////////
*/
[BITS 32]

@RAT	EQU	0x04000000

OFFSET_HISTORY	EQU	0x00000000

OFFSET_DISABLE	EQU	0x00000000

NumRte0X		EQU 0x0019

NumRteLoc		EQU 0x002A

;Safe code.


[GLOBAL DebugLabel0]

DebugLabel0:				;DFB SECTION PROLOG

	ENTER 	0x0,0

%if 0x0>0

				;Stack cleaning

GLOBAL_LABEL0:

	XOR	EAX,EAX

	XOR	EDX,EDX

	MOV	ECX,-0x0

Node_4_loop:

	SUB	EDX,4

	MOV	[EBP+EDX],EAX

	CMP	EDX,ECX

	JNE	Node_4_loop

%endif

	PUSH	DWORD	EDI	;Save previous physical DFB instance

[GLOBAL DebugLabel1]

DebugLabel1:

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x0]

	;PhD AND	EAX,0x01	;COND1

	AND AL,1 ; PhD3 added otherwise cmp doesn't work correctly

	CMP	AL,0x0

	SETE	AL

	;PhD AND	EAX,1

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf1

[GLOBAL DebugLabel2]

DebugLabel2:

					;

	MOV	AX, 0x1

	

	MOV	EBX,EDI

	MOV	[EBX + 0x12 + 0x0],AX	;PIN_NB

	

[GLOBAL DebugLabel3]

DebugLabel3:

					;

	MOV	EAX, 0x1

	

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x14 + 0x0],AL	;PIN_VAL

	

[GLOBAL LD_$labEndIf1]

LD_$labEndIf1:

[GLOBAL DebugLabel4]

DebugLabel4:

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x1]

	;PhD AND	EAX,0x01	;COND0

	AND AL,1 ; PhD3 added otherwise cmp doesn't work correctly

	CMP	AL,0x1

	SETE	AL

	;PhD AND	EAX,1

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf2

[GLOBAL DebugLabel5]

DebugLabel5:

					;

	MOV	AX, 0x2

	

	MOV	EBX,EDI

	MOV	[EBX + 0x12 + 0x0],AX	;PIN_NB

	

[GLOBAL DebugLabel6]

DebugLabel6:

					;

	MOV	EAX, 0x0

	

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x14 + 0x0],AL	;PIN_VAL

	

[GLOBAL LD_$labEndIf2]

LD_$labEndIf2:

[GLOBAL DebugLabel7]

DebugLabel7:

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x0]

	;PhD AND	EAX,0x01	;COND1

	PUSH	EAX	;COND1

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x1]

	;PhD AND	EAX,0x01	;COND0

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labElse4

[GLOBAL DebugLabel8]

DebugLabel8:

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x2]

	;PhD AND	EAX,0x01	;ERROR

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf5

[GLOBAL DebugLabel9]

DebugLabel9:

	PUSH	DWORD	EDI	;Save physical D F B instance

	; clear previous stack usage 0x0

				; push the selector and the offset onto the stack

				;ACCU EA, VAL, NO ARRAY

				;%SW77

	MOV	ECX,0xea	;OFF

	MOV	EAX,0x2b	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =4bytes

	PUSH	DWORD	EAX

				;Stack parameter size =8bytes

				; push the word value onto the stack

	MOV	EBX,EDI

	MOV	AX,[EBX + 0x8 + 0x0]	;ERROR_ID

	PUSH	EAX

				;Stack parameter size =12bytes

					;EF_CALL

[EXTERN _DEREG]

[EXTERN _DEREG_OFFSET]

	XOR	EBX,EBX

	MOV	BX,_DEREG

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,_DEREG_OFFSET

	CALL	EBX

				; clean the stack

	ADD	ESP,12

	POP	DWORD EDI	;Restore physical DFB instance

[GLOBAL DebugLabel10]

DebugLabel10:

	XOR	EAX,EAX

				;Unlocated unforcable

GLOBAL_LABEL1:

	MOV	EBX,EDI

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x2]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x2],DL	;ERROR

	MOV	EAX,1

[GLOBAL DebugLabel11]

DebugLabel11:

	XOR	EAX,EAX

				;Unlocated unforcable

GLOBAL_LABEL2:

	MOV	EBX,EDI

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x10]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x10],DL	;BUFPLEIN

	MOV	EAX,1

[GLOBAL LD_$labEndIf5]

LD_$labEndIf5:

	JMP	LD_$labEndIf3

[GLOBAL LD_$labElse4]

LD_$labElse4:

[GLOBAL DebugLabel12]

DebugLabel12:

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x2]

	;PhD AND	EAX,0x01	;ERROR

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labElse7

[GLOBAL DebugLabel13]

DebugLabel13:

	PUSH	DWORD	EDI	;Save physical D F B instance

	; clear previous stack usage 0x0

				; push the selector and the offset onto the stack

				;ACCU EA, VAL, NO ARRAY

				;%SW76

	MOV	ECX,0xe8	;OFF

	MOV	EAX,0x2b	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =4bytes

	PUSH	DWORD	EAX

				;Stack parameter size =8bytes

				; push the selector and the offset onto the stack

				;ACCU EA, DFB, DATA AREA, VAL

				;ERROR_ID

	MOV	ECX,0x8	; OFF PhD modif le 14052002

	MOV	EAX,[EBP+0x08]	        ; RTE PhD modif le 14052002

	PUSH	DWORD	ECX

				;Stack parameter size =12bytes

	PUSH	DWORD	EAX

				;Stack parameter size =16bytes

				; push the selector and the offset onto the stack

	MOV	ECX,0xc	;OFF

	MOV	EAX,[EBP+8]	;RTE of the current data area

	MOV	EDX,0x4	;Number of element

	PUSH	DWORD	EDX	;LN

				;Stack parameter size =20bytes

	PUSH	DWORD	ECX	;OFF

				;Stack parameter size =24bytes

	PUSH	DWORD	EAX	;RTE

				;Stack parameter size =28bytes

				; push the selector and the offset onto the stack

						;

	MOV	EBX,EDI

	MOV	ESI,[EBX + 0x18 + 4]	;Get offset from the dta_area

	MOV	BX,[EBX + 0x18]		;Get RTE from the dta_area

	AND	EBX,0x0FFFF

	ADD	ESI,0x0

	MOV	ECX,ESI	;OFF

	MOV	EAX,EBX	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =32bytes

	PUSH	DWORD	EAX

				;Stack parameter size =36bytes

				; push the bool value onto the stack

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x14 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;PIN_VAL

	AND EAX,1

	PUSH	EAX	;

				;Stack parameter size =40bytes

				; push the word value onto the stack

	MOV	EBX,EDI

	MOV	AX,[EBX + 0x12 + 0x0]	;PIN_NB

	PUSH	EAX

				;Stack parameter size =44bytes

				; push the ebool value onto the stack

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x6]

	;PhD AND	EAX,0x01	;OP_CTRL

	AND EAX,1

	PUSH	EAX	;

				;Stack parameter size =48bytes

				; push the word value onto the stack

	PUSH	DWORD 0x0

				;Stack parameter size =52bytes

				; push the word value onto the stack

	PUSH	DWORD 0x43

				;Stack parameter size =56bytes

				; push the word value onto the stack

	MOV	EBX,EDI

	MOV	AX,[EBX + 0x4 + 0x0]	;AREA_NR

	PUSH	EAX

				;Stack parameter size =60bytes

					;EF_CALL

[EXTERN _REGDFB]

[EXTERN _REGDFB_OFFSET]

	XOR	EBX,EBX

	MOV	BX,_REGDFB

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,_REGDFB_OFFSET

	CALL	EBX

				; clean the stack

	ADD	ESP,60

	POP	DWORD EDI	;Restore physical DFB instance

[GLOBAL DebugLabel14]

DebugLabel14:

	MOV	EBX,[@RAT+0x2b*8]

	MOV	AX,[EBX + 0xe8 + 0x0]	;%SW76

	CMP	AX,0x0

	JE NEAR	LD_$labEndIf8

[GLOBAL DebugLabel15]

DebugLabel15:

	MOV	EAX,1

				;Unlocated unforcable

GLOBAL_LABEL3:

	MOV	EBX,EDI

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x10]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x10],DL	;BUFPLEIN

[GLOBAL LD_$labEndIf8]

LD_$labEndIf8:

[GLOBAL DebugLabel16]

DebugLabel16:

	MOV	EAX,1

				;Unlocated unforcable

GLOBAL_LABEL4:

	MOV	EBX,EDI

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x2]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x2],DL	;ERROR

	JMP	LD_$labEndIf6

[GLOBAL LD_$labElse7]

LD_$labElse7:

[GLOBAL DebugLabel17]

DebugLabel17:

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10]

	;PhD AND	EAX,0x01	;BUFPLEIN

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf9

[GLOBAL DebugLabel18]

DebugLabel18:

	PUSH	DWORD	EDI	;Save physical D F B instance

	; clear previous stack usage 0x0

				; push the selector and the offset onto the stack

				;ACCU EA, VAL, NO ARRAY

				;%SW76

	MOV	ECX,0xe8	;OFF

	MOV	EAX,0x2b	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =4bytes

	PUSH	DWORD	EAX

				;Stack parameter size =8bytes

				; push the selector and the offset onto the stack

				;ACCU EA, DFB, DATA AREA, VAL

				;ERROR_ID

	MOV	ECX,0x8	; OFF PhD modif le 14052002

	MOV	EAX,[EBP+0x08]	        ; RTE PhD modif le 14052002

	PUSH	DWORD	ECX

				;Stack parameter size =12bytes

	PUSH	DWORD	EAX

				;Stack parameter size =16bytes

				; push the selector and the offset onto the stack

	MOV	ECX,0xc	;OFF

	MOV	EAX,[EBP+8]	;RTE of the current data area

	MOV	EDX,0x4	;Number of element

	PUSH	DWORD	EDX	;LN

				;Stack parameter size =20bytes

	PUSH	DWORD	ECX	;OFF

				;Stack parameter size =24bytes

	PUSH	DWORD	EAX	;RTE

				;Stack parameter size =28bytes

				; push the selector and the offset onto the stack

						;

	MOV	EBX,EDI

	MOV	ESI,[EBX + 0x18 + 4]	;Get offset from the dta_area

	MOV	BX,[EBX + 0x18]		;Get RTE from the dta_area

	AND	EBX,0x0FFFF

	ADD	ESI,0x0

	MOV	ECX,ESI	;OFF

	MOV	EAX,EBX	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =32bytes

	PUSH	DWORD	EAX

				;Stack parameter size =36bytes

				; push the bool value onto the stack

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x14 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;PIN_VAL

	AND EAX,1

	PUSH	EAX	;

				;Stack parameter size =40bytes

				; push the word value onto the stack

	MOV	EBX,EDI

	MOV	AX,[EBX + 0x12 + 0x0]	;PIN_NB

	PUSH	EAX

				;Stack parameter size =44bytes

				; push the ebool value onto the stack

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x6]

	;PhD AND	EAX,0x01	;OP_CTRL

	AND EAX,1

	PUSH	EAX	;

				;Stack parameter size =48bytes

				; push the word value onto the stack

	PUSH	DWORD 0x0

				;Stack parameter size =52bytes

				; push the word value onto the stack

	PUSH	DWORD 0x43

				;Stack parameter size =56bytes

				; push the word value onto the stack

	MOV	EBX,EDI

	MOV	AX,[EBX + 0x4 + 0x0]	;AREA_NR

	PUSH	EAX

				;Stack parameter size =60bytes

					;EF_CALL

[EXTERN _REGDFB]

[EXTERN _REGDFB_OFFSET]

	XOR	EBX,EBX

	MOV	BX,_REGDFB

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,_REGDFB_OFFSET

	CALL	EBX

				; clean the stack

	ADD	ESP,60

	POP	DWORD EDI	;Restore physical DFB instance

[GLOBAL DebugLabel19]

DebugLabel19:

	MOV	EBX,[@RAT+0x2b*8]

	MOV	AX,[EBX + 0xe8 + 0x0]	;%SW76

	CMP	AX,0x0

	JNE NEAR	LD_$labEndIf10

[GLOBAL DebugLabel20]

DebugLabel20:

	XOR	EAX,EAX

				;Unlocated unforcable

GLOBAL_LABEL5:

	MOV	EBX,EDI

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x10]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x10],DL	;BUFPLEIN

	MOV	EAX,1

[GLOBAL LD_$labEndIf10]

LD_$labEndIf10:

[GLOBAL LD_$labEndIf9]

LD_$labEndIf9:

[GLOBAL LD_$labEndIf6]

LD_$labEndIf6:

[GLOBAL LD_$labEndIf3]

LD_$labEndIf3:

				; SECTION DFB EPILOG with no animation link

	XOR	EAX,EAX; Clear EAX to continue to the nexte section

end_section:

[GLOBAL DebugLabel21]

DebugLabel21:					; DFB EPIL0G

	POP	DWORD	EDI	;Restore physical DFB instance

	LEAVE

	RET
