/*
////////////////////////////
backendResu.asm
rte/offset mode
	OS time:	16:24:20
	OS date:	04/11/19
////////////////////////////
*/
[BITS 32]

@RAT	EQU	0x04000000

OFFSET_HISTORY	EQU	0x00000000

OFFSET_DISABLE	EQU	0x00000000

NumRte0X		EQU 0x0019

NumRteLoc		EQU 0x002A

;Safe code.


[GLOBAL DebugLabel0]

DebugLabel0:				;DFB SECTION PROLOG

	ENTER 	0x0,0

%if 0x0>0

				;Stack cleaning

GLOBAL_LABEL38:

	XOR	EAX,EAX

	XOR	EDX,EDX

	MOV	ECX,-0x0

Node_4_loop:

	SUB	EDX,4

	MOV	[EBP+EDX],EAX

	CMP	EDX,ECX

	JNE	Node_4_loop

%endif

	PUSH	DWORD	EDI	;Save previous physical DFB instance

[GLOBAL DebugLabel1]

DebugLabel1:

	MOV	EBX,EDI

	MOV	AL,[EBX + 0xa + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;fdbk_info

	AND AL,1 ; PhD3 added otherwise cmp doesn't work correctly

	CMP	AL,0x1

	SETE	AL

	;PhD AND	EAX,1

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labElse2

[GLOBAL DebugLabel2]

DebugLabel2:

					;

	MOV	AX, 0x5

	

	MOV	EBX,EDI

	MOV	[EBX + 0x26 + 0x0],AX	;PIN_NB

	

[GLOBAL DebugLabel3]

DebugLabel3:

					;

	MOV	EAX, 0x1

	

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x28 + 0x0],AL	;PIN_VAL

	

	JMP	LD_$labEndIf1

[GLOBAL LD_$labElse2]

LD_$labElse2:

[GLOBAL DebugLabel4]

DebugLabel4:

					;

	MOV	AX, 0x0

	

	MOV	EBX,EDI

	MOV	[EBX + 0x26 + 0x0],AX	;PIN_NB

	

[GLOBAL DebugLabel5]

DebugLabel5:

					;

	MOV	EAX, 0x0

	

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x28 + 0x0],AL	;PIN_VAL

	

[GLOBAL LD_$labEndIf1]

LD_$labEndIf1:

[GLOBAL DebugLabel6]

DebugLabel6:

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x0 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;ED

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf3

[GLOBAL DebugLabel7]

DebugLabel7:

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x7 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;ERROR

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf4

[GLOBAL DebugLabel8]

DebugLabel8:

	PUSH	DWORD	EDI	;Save physical D F B instance

	; clear previous stack usage 0x0

				; push the selector and the offset onto the stack

				;ACCU EA, VAL, NO ARRAY

				;%SW77

	MOV	ECX,0xea	;OFF

	MOV	EAX,0x2b	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =4bytes

	PUSH	DWORD	EAX

				;Stack parameter size =8bytes

				; push the word value onto the stack

	MOV	EBX,EDI

	MOV	AX,[EBX + 0x1c + 0x0]	;ERROR_ID

	PUSH	EAX

				;Stack parameter size =12bytes

					;EF_CALL

[EXTERN _DEREG]

[EXTERN _DEREG_OFFSET]

	XOR	EBX,EBX

	MOV	BX,_DEREG

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,_DEREG_OFFSET

	CALL	EBX

				; clean the stack

	ADD	ESP,12

	POP	DWORD EDI	;Restore physical DFB instance

[GLOBAL DebugLabel9]

DebugLabel9:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x7 + 0x0],AL	;ERROR

	MOV	EAX,1

[GLOBAL DebugLabel10]

DebugLabel10:

					;

%if 0x0=0

	XOR	EAX,EAX

%else

	MOV	EAX, 0x0

%endif

	

	MOV	EBX,EDI

	MOV	[EBX + 0x20 + 0x0],EAX	;STATUS

	

[GLOBAL LD_$labEndIf4]

LD_$labEndIf4:

[GLOBAL DebugLabel11]

DebugLabel11:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x24 + 0x0],AL	;BUFFULL

	MOV	EAX,1

[GLOBAL DebugLabel12]

DebugLabel12:

	; dfb scheduler return node

	MOV EAX,0x01; Set accumulator

	JMP end_section

[GLOBAL LD_$labEndIf3]

LD_$labEndIf3:

[GLOBAL DebugLabel13]

DebugLabel13:

	MOV	EBX,EDI

	MOV	AL,[EBX + 0xa + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;fdbk_info

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labElse6

[GLOBAL DebugLabel14]

DebugLabel14:

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x7 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;ERROR

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf7

[GLOBAL DebugLabel15]

DebugLabel15:

	PUSH	DWORD	EDI	;Save physical D F B instance

	; clear previous stack usage 0x0

				; push the selector and the offset onto the stack

				;ACCU EA, VAL, NO ARRAY

				;%SW77

	MOV	ECX,0xea	;OFF

	MOV	EAX,0x2b	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =4bytes

	PUSH	DWORD	EAX

				;Stack parameter size =8bytes

				; push the word value onto the stack

	MOV	EBX,EDI

	MOV	AX,[EBX + 0x1c + 0x0]	;ERROR_ID

	PUSH	EAX

				;Stack parameter size =12bytes

					;EF_CALL

[EXTERN _DEREG]

[EXTERN _DEREG_OFFSET]

	XOR	EBX,EBX

	MOV	BX,_DEREG

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,_DEREG_OFFSET

	CALL	EBX

				; clean the stack

	ADD	ESP,12

	POP	DWORD EDI	;Restore physical DFB instance

[GLOBAL DebugLabel16]

DebugLabel16:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x7 + 0x0],AL	;ERROR

	MOV	EAX,1

[GLOBAL LD_$labEndIf7]

LD_$labEndIf7:

[GLOBAL DebugLabel17]

DebugLabel17:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x24 + 0x0],AL	;BUFFULL

	MOV	EAX,1

	JMP	LD_$labEndIf5

[GLOBAL LD_$labElse6]

LD_$labElse6:

[GLOBAL DebugLabel18]

DebugLabel18:

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x7 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;ERROR

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labElse9

[GLOBAL DebugLabel19]

DebugLabel19:

	PUSH	DWORD	EDI	;Save physical D F B instance

	; clear previous stack usage 0x0

				; push the selector and the offset onto the stack

				;ACCU EA, VAL, NO ARRAY

				;%SW76

	MOV	ECX,0xe8	;OFF

	MOV	EAX,0x2b	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =4bytes

	PUSH	DWORD	EAX

				;Stack parameter size =8bytes

				; push the selector and the offset onto the stack

				;ACCU EA, DFB, DATA AREA, VAL

				;ERROR_ID

	MOV	ECX,0x1c	; OFF PhD modif le 14052002

	MOV	EAX,[EBP+0x08]	        ; RTE PhD modif le 14052002

	PUSH	DWORD	ECX

				;Stack parameter size =12bytes

	PUSH	DWORD	EAX

				;Stack parameter size =16bytes

				; push the selector and the offset onto the stack

	MOV	ECX,0x20	;OFF

	MOV	EAX,[EBP+8]	;RTE of the current data area

	MOV	EDX,0x4	;Number of element

	PUSH	DWORD	EDX	;LN

				;Stack parameter size =20bytes

	PUSH	DWORD	ECX	;OFF

				;Stack parameter size =24bytes

	PUSH	DWORD	EAX	;RTE

				;Stack parameter size =28bytes

				; push the selector and the offset onto the stack

						;

	MOV	EBX,EDI

	MOV	ESI,[EBX + 0x54 + 4]	;Get offset from the dta_area

	MOV	BX,[EBX + 0x54]		;Get RTE from the dta_area

	AND	EBX,0x0FFFF

	ADD	ESI,0x0

	MOV	ECX,ESI	;OFF

	MOV	EAX,EBX	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =32bytes

	PUSH	DWORD	EAX

				;Stack parameter size =36bytes

				; push the bool value onto the stack

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x28 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;PIN_VAL

	AND EAX,1

	PUSH	EAX	;

				;Stack parameter size =40bytes

				; push the word value onto the stack

	MOV	EBX,EDI

	MOV	AX,[EBX + 0x26 + 0x0]	;PIN_NB

	PUSH	EAX

				;Stack parameter size =44bytes

				; push the bool value onto the stack

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x12 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;OP_CTRL

	AND EAX,1

	PUSH	EAX	;

				;Stack parameter size =48bytes

				; push the word value onto the stack

	PUSH	DWORD 0x0

				;Stack parameter size =52bytes

				; push the word value onto the stack

	PUSH	DWORD 0x62

				;Stack parameter size =56bytes

				; push the word value onto the stack

	MOV	EBX,EDI

	MOV	AX,[EBX + 0x10 + 0x0]	;AREA_NR

	PUSH	EAX

				;Stack parameter size =60bytes

					;EF_CALL

[EXTERN _REGDFB]

[EXTERN _REGDFB_OFFSET]

	XOR	EBX,EBX

	MOV	BX,_REGDFB

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,_REGDFB_OFFSET

	CALL	EBX

				; clean the stack

	ADD	ESP,60

	POP	DWORD EDI	;Restore physical DFB instance

[GLOBAL DebugLabel20]

DebugLabel20:

	MOV	EAX,1

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x7 + 0x0],AL	;ERROR

[GLOBAL DebugLabel21]

DebugLabel21:

	MOV	EBX,[@RAT+0x2b*8]

	MOV	AX,[EBX + 0xe8 + 0x0]	;%SW76

	CMP	AX,0x0

	JE NEAR	LD_$labEndIf10

[GLOBAL DebugLabel22]

DebugLabel22:

	MOV	EAX,1

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x24 + 0x0],AL	;BUFFULL

[GLOBAL LD_$labEndIf10]

LD_$labEndIf10:

	JMP	LD_$labEndIf8

[GLOBAL LD_$labElse9]

LD_$labElse9:

[GLOBAL DebugLabel23]

DebugLabel23:

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x24 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;BUFFULL

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf11

[GLOBAL DebugLabel24]

DebugLabel24:

	PUSH	DWORD	EDI	;Save physical D F B instance

	; clear previous stack usage 0x0

				; push the selector and the offset onto the stack

				;ACCU EA, VAL, NO ARRAY

				;%SW76

	MOV	ECX,0xe8	;OFF

	MOV	EAX,0x2b	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =4bytes

	PUSH	DWORD	EAX

				;Stack parameter size =8bytes

				; push the selector and the offset onto the stack

				;ACCU EA, DFB, DATA AREA, VAL

				;ERROR_ID

	MOV	ECX,0x1c	; OFF PhD modif le 14052002

	MOV	EAX,[EBP+0x08]	        ; RTE PhD modif le 14052002

	PUSH	DWORD	ECX

				;Stack parameter size =12bytes

	PUSH	DWORD	EAX

				;Stack parameter size =16bytes

				; push the selector and the offset onto the stack

	MOV	ECX,0x20	;OFF

	MOV	EAX,[EBP+8]	;RTE of the current data area

	MOV	EDX,0x4	;Number of element

	PUSH	DWORD	EDX	;LN

				;Stack parameter size =20bytes

	PUSH	DWORD	ECX	;OFF

				;Stack parameter size =24bytes

	PUSH	DWORD	EAX	;RTE

				;Stack parameter size =28bytes

				; push the selector and the offset onto the stack

						;

	MOV	EBX,EDI

	MOV	ESI,[EBX + 0x54 + 4]	;Get offset from the dta_area

	MOV	BX,[EBX + 0x54]		;Get RTE from the dta_area

	AND	EBX,0x0FFFF

	ADD	ESI,0x0

	MOV	ECX,ESI	;OFF

	MOV	EAX,EBX	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =32bytes

	PUSH	DWORD	EAX

				;Stack parameter size =36bytes

				; push the bool value onto the stack

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x28 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;PIN_VAL

	AND EAX,1

	PUSH	EAX	;

				;Stack parameter size =40bytes

				; push the word value onto the stack

	MOV	EBX,EDI

	MOV	AX,[EBX + 0x26 + 0x0]	;PIN_NB

	PUSH	EAX

				;Stack parameter size =44bytes

				; push the bool value onto the stack

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x12 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;OP_CTRL

	AND EAX,1

	PUSH	EAX	;

				;Stack parameter size =48bytes

				; push the word value onto the stack

	PUSH	DWORD 0x0

				;Stack parameter size =52bytes

				; push the word value onto the stack

	PUSH	DWORD 0x62

				;Stack parameter size =56bytes

				; push the word value onto the stack

	MOV	EBX,EDI

	MOV	AX,[EBX + 0x10 + 0x0]	;AREA_NR

	PUSH	EAX

				;Stack parameter size =60bytes

					;EF_CALL

[EXTERN _REGDFB]

[EXTERN _REGDFB_OFFSET]

	XOR	EBX,EBX

	MOV	BX,_REGDFB

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,_REGDFB_OFFSET

	CALL	EBX

				; clean the stack

	ADD	ESP,60

	POP	DWORD EDI	;Restore physical DFB instance

[GLOBAL DebugLabel25]

DebugLabel25:

	MOV	EBX,[@RAT+0x2b*8]

	MOV	AX,[EBX + 0xe8 + 0x0]	;%SW76

	CMP	AX,0x0

	JNE NEAR	LD_$labEndIf12

[GLOBAL DebugLabel26]

DebugLabel26:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x24 + 0x0],AL	;BUFFULL

	MOV	EAX,1

[GLOBAL LD_$labEndIf12]

LD_$labEndIf12:

[GLOBAL LD_$labEndIf11]

LD_$labEndIf11:

[GLOBAL LD_$labEndIf8]

LD_$labEndIf8:

[GLOBAL LD_$labEndIf5]

LD_$labEndIf5:

				; SECTION DFB EPILOG with no animation link

	XOR	EAX,EAX; Clear EAX to continue to the nexte section

end_section:

[GLOBAL DebugLabel27]

DebugLabel27:					; DFB EPIL0G

	POP	DWORD	EDI	;Restore physical DFB instance

	LEAVE

	RET
