/*
////////////////////////////
backendResu.asm
rte/offset mode
	OS time:	16:24:20
	OS date:	04/11/19
////////////////////////////
*/
[BITS 32]

@RAT	EQU	0x04000000

OFFSET_HISTORY	EQU	0x00000000

OFFSET_DISABLE	EQU	0x00000000

NumRte0X		EQU 0x0019

NumRteLoc		EQU 0x002A

;Safe code.


[GLOBAL DebugLabel0]

DebugLabel0:				;DFB SECTION PROLOG

	ENTER 	0x64,0

%if 0x64>0

				;Stack cleaning

GLOBAL_LABEL39:

	XOR	EAX,EAX

	XOR	EDX,EDX

	MOV	ECX,-0x64

Node_4_loop:

	SUB	EDX,4

	MOV	[EBP+EDX],EAX

	CMP	EDX,ECX

	JNE	Node_4_loop

%endif

	PUSH	DWORD	EDI	;Save previous physical DFB instance

[GLOBAL DebugLabel1]

DebugLabel1:

					;

					;

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x1 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;start

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x4],AL	;$LINK10

	

	PUSH	EAX

					;

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x8 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;running_left

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x8],AL	;$LINK11

	

	POP	ECX

	OR	AL,CL

	MOV	[EBP -0xc],EAX

	PUSH	EAX

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x3 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;left_direction

	POP	ECX

	AND	AL,CL

	MOV	[EBP -0x10],EAX

	PUSH	EAX

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x2 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;stop

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	MOV	[EBP -0x14],EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x8 + 0x0],AL	;running_left

	MOV	[EBP -0x18],EAX

[GLOBAL DebugLabel2]

DebugLabel2:

					;

					;

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x1 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;start

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x1c],AL	;$LINK16

	

	PUSH	EAX

					;

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x9 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;running_right

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x20],AL	;$LINK17

	

	POP	ECX

	OR	AL,CL

	MOV	[EBP -0x24],EAX

	PUSH	EAX

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x4 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;right_direction

	POP	ECX

	AND	AL,CL

	MOV	[EBP -0x28],EAX

	PUSH	EAX

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x2 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;stop

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	MOV	[EBP -0x2c],EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x9 + 0x0],AL	;running_right

	MOV	[EBP -0x30],EAX

[GLOBAL DebugLabel3]

DebugLabel3:

					;

					;

					;

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x5 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;fdbk_simul

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x34],AL	;$LINK23

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x38],AL	;$LINK24

	

	PUSH	EAX

					;

	MOV	AL,[EBP - 0x38]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK24

	PUSH	EAX

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x8 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;running_left

	POP	ECX

	AND	AL,CL

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x3c],AL	;$LINK26

	

	PUSH	EAX

					;

	MOV	AL,[EBP - 0x38]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK24

	PUSH	EAX

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x9 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;running_right

	POP	ECX

	AND	AL,CL

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x40],AL	;$LINK27

	

	POP	ECX

	OR	AL,CL

	

	POP	ECX

	AND	AL,CL

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x44],AL	;$LINK28

	

					;

	MOV	AL,[EBP - 0x44]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK28

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x31 + 0x0],AL	;IN

	

					;

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;simul_preset

	MOV	EBX,EDI

	MOV	[EBX + 0x34 + 0x0],EAX	;PT

	

	PUSH	DWORD	EDI	;Save physical DFB instance

	; clear previous stack usage 0x0

				; push the selector and the offset onto the stack

				;ACCU EA, DFB, DATA AREA, VAL

				;simul_timer

	MOV	ECX,0x2c	; OFF PhD modif le 14052002

	MOV	EAX,[EBP+0x08]	        ; RTE PhD modif le 14052002

	PUSH	DWORD	ECX

				;Stack parameter size =4bytes

	PUSH	DWORD	EAX

				;Stack parameter size =8bytes

				;EFB_CALL

[EXTERN _TON_RTE]

[EXTERN _TON_OFFSET]

	XOR	EBX,EBX

	MOV	BX,_TON_RTE

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,_TON_OFFSET

	CALL	EBX

				; clean the stack

	ADD	ESP,8

	POP	DWORD EDI	;Restore physical DFB instance

[GLOBAL DebugLabel4]

DebugLabel4:

					;

					;

					;

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x8 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;running_left

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x48],AL	;$LINK30

	

	PUSH	EAX

					;

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x9 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;running_right

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x4c],AL	;$LINK31

	

	POP	ECX

	OR	AL,CL

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x50],AL	;$LINK32

	

	PUSH	EAX

					;

	MOV	AL,[EBP - 0x50]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK32

	PUSH	EAX

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x5 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;fdbk_simul

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x54],AL	;$LINK34

	

	PUSH	EAX

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x6 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;feedback

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	MOV	[EBP -0x58],EAX

	PUSH	EAX

					;

	MOV	AL,[EBP - 0x50]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK32

	PUSH	EAX

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x5 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;fdbk_simul

	POP	ECX

	AND	AL,CL

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x5c],AL	;$LINK38

	

	PUSH	EAX

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x38 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Q

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	MOV	[EBP -0x60],EAX

	POP	ECX

	OR	AL,CL

	

	POP	ECX

	AND	AL,CL

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x64],AL	;$LINK37

	

					;

	MOV	AL,[EBP - 0x64]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK37

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x45 + 0x0],AL	;IN

	

					;

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x18 + 0x0]	;fdbk_preset

	MOV	EBX,EDI

	MOV	[EBX + 0x48 + 0x0],EAX	;PT

	

	PUSH	DWORD	EDI	;Save physical DFB instance

	; clear previous stack usage 0x0

				; push the selector and the offset onto the stack

				;ACCU EA, DFB, DATA AREA, VAL

				;fdbk

	MOV	ECX,0x40	; OFF PhD modif le 14052002

	MOV	EAX,[EBP+0x08]	        ; RTE PhD modif le 14052002

	PUSH	DWORD	ECX

				;Stack parameter size =4bytes

	PUSH	DWORD	EAX

				;Stack parameter size =8bytes

				;EFB_CALL

[EXTERN _TON_RTE]

[EXTERN _TON_OFFSET]

	XOR	EBX,EBX

	MOV	BX,_TON_RTE

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,_TON_OFFSET

	CALL	EBX

				; clean the stack

	ADD	ESP,8

	POP	DWORD EDI	;Restore physical DFB instance

					;

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x4c + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Q

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0xa + 0x0],AL	;fdbk_info

	

					;

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x50 + 0x0]	;ET

	MOV	EBX,EDI

	MOV	[EBX + 0xc + 0x0],EAX	;fdbk_et

	

					;SECTION DFB EPIL0G

			;EPIL0G with center child and a section DFB

	XOR	EAX,EAX; 	Clear accumulator

end_section:

	PUSH	EAX

	; tree for animation link

	; If the symbl is not null, animate

	MOV	EBX,EDI

	MOV	AX,[EBX + 0x5c + 0x0]

	OR	AX,AX		; Update flags for jump

	JZ	end_animation

	;proto for s_link_anim(	unsigned short sctionvar

  	;			unsigned int BP

	;			unsigned short SS)

	; push the SS segment value 0 in flat mode

	PUSH	DWORD 0x0	;Parameters are on 32bits

					;Stack parameter size =4bytes

	; push the physical stack address

	PUSH 	DWORD EBP

					;Stack parameter size =8bytes

	; here we call the animation service

	PUSH 	DWORD EAX	;Parameters are on 32bits

					;Stack parameter size =12bytes

	XOR	EBX,EBX

	; get the system call number for link animation

					;SYS_CALL

	PUSH	DWORD 0x28

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,4

	CALL	EAX

	ADD	ESP,12

end_animation:

	POP	EAX

[GLOBAL DebugLabel5]

DebugLabel5:

	POP	DWORD	EDI	;Restore physical DFB instance

	LEAVE

	RET
