/*
////////////////////////////
backendResu.asm
rte/offset mode
	OS time:	16:24:20
	OS date:	04/11/19
////////////////////////////
*/
[BITS 32]

@RAT	EQU	0x04000000

OFFSET_HISTORY	EQU	0x00000000

OFFSET_DISABLE	EQU	0x00000000

NumRte0X		EQU 0x0019

NumRteLoc		EQU 0x002A

;Safe code.


[GLOBAL DebugLabel0]

DebugLabel0:			;SECTION PROLOG

	ENTER	0x34,0

%if 0x34>0

				;Stack cleaning

GLOBAL_LABEL41:

	XOR	EAX,EAX

	XOR	EDX,EDX

	MOV	ECX,-0x34

Node_4_loop:

	SUB	EDX,4

	MOV	[EBP+EDX],EAX

	CMP	EDX,ECX

	JNE	Node_4_loop

%endif

[GLOBAL DebugLabel1]

DebugLabel1:

					;

					;

					;

					;

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x38f + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Start

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x4],AL	;$LINK407

	

	PUSH	EAX

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x361]

	;PhD AND	EAX,0x01	;Start_process

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x8],AL	;$LINK417

	

	POP	ECX

	OR	AL,CL

	MOV	[EBP -0xc],EAX

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x390 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Stop

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	MOV	[EBP -0x10],EAX

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x14],AL	;$LINK413

	

				;Unlocated unforcable

GLOBAL_LABEL42:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x361]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x361],DL	;Start_process

	MOV	[EBP -0x18],EAX

				;Unlocated forcable

GLOBAL_LABEL43:

	MOV	EBX,[@RAT+0x2d*8]

	MOV	DH,AL	; Keep EAX for multi assign

	MOV	CL,[EBX + 0x2d]

	MOV	DL,CL

	AND	DL,0x01	; reset F and H

	AND	CL,0x04	; test F value

	JZ	Node_42_NotForced

	MOV	DH,DL		; F=1 -> ACCU=D

	OR	DL,0x02	; set H (became F after shift)

Node_42_NotForced:

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x2d],DL	;Machine_running

	MOV	[EBP -0x1c],EAX

[GLOBAL DebugLabel2]

DebugLabel2:

					;

					;

					;

					;

					;

					;

	MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x361]	;Start_process

	AND	EAX,0x03

	CMP	EAX,0x01

	SETZ	AL

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x20],AL	;$LINK420

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x24],AL	;$LINK403

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x28],AL	;$LINK404

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x2c],AL	;$LINK405

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x30],AL	;$LINK406

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x34],AL	;$LINK422

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$CondLabel1

					;

	MOV	AX, 0x3e8

	

;MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x7a + 0x0],AX	;cv_Material_A

	

					;

	MOV	AX, 0x3e8

	

;MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x7c + 0x0],AX	;cv_Material_B

	

					;

	MOV	AX, 0x32

	

;MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x78 + 0x0],AX	;material_a_value

	

					;

	MOV	AX, 0x14

	

;MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x36 + 0x0],AX	;material_b_value

	

[GLOBAL LD_$CondLabel1]

LD_$CondLabel1:

			;SECTION EPIL0G with center child and not a section DFB

	XOR	EAX,EAX; 	Clear accumulator

end_section:

	PUSH	EAX

	; tree for animation link

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x334 + 0x0]

	OR	AX,AX		; Update flags for jump

	JZ	end_animation

	;proto for s_link_anim(	unsigned short sctionvar

  	;			unsigned int BP

	;			unsigned short SS)

	; push the SS segment value 0 in flat mode

	PUSH	DWORD 0x0	;Parameters are on 32bits

					;Stack parameter size =4bytes

	; push the physical stack address

	PUSH 	DWORD EBP

					;Stack parameter size =8bytes

	; here we call the animation service

	PUSH 	DWORD EAX	;Parameters are on 32bits

					;Stack parameter size =12bytes

	XOR	EBX,EBX

	; get the system call number for link animation

					;SYS_CALL

	PUSH	DWORD 0x28

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,4

	CALL	EAX

	ADD	ESP,12

end_animation:

	POP	EAX

[GLOBAL DebugLabel3]

DebugLabel3:

	LEAVE

	RET
