/*
////////////////////////////
backendResu.asm
rte/offset mode
	OS time:	16:24:20
	OS date:	04/11/19
////////////////////////////
*/
[BITS 32]

@RAT	EQU	0x04000000

OFFSET_HISTORY	EQU	0x00000000

OFFSET_DISABLE	EQU	0x00000000

NumRte0X		EQU 0x0019

NumRteLoc		EQU 0x002A

;Safe code.


[GLOBAL DebugLabel0]

DebugLabel0:			;SECTION PROLOG

	ENTER	0xc,0

%if 0xc>0

				;Stack cleaning

GLOBAL_LABEL64:

	XOR	EAX,EAX

	XOR	EDX,EDX

	MOV	ECX,-0xc

Node_4_loop:

	SUB	EDX,4

	MOV	[EBP+EDX],EAX

	CMP	EDX,ECX

	JNE	Node_4_loop

%endif

[GLOBAL DebugLabel1]

DebugLabel1:

					;

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x34b + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;ready_to_mix

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x367]

	;PhD AND	EAX,0x01	;Valve_B_closed

	POP	ECX

	AND	AL,CL

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x4],AL	;$LINK427

	

[GLOBAL DebugLabel2]

DebugLabel2:

					;

	MOV	AL,[EBP - 0x4]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK427

	MOV	EBX,[@RAT+0x32*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x91 + 0x0],AL	;IN

	

					;

%if 0x2710=0

	XOR	EAX,EAX

%else

	MOV	EAX, 0x2710

%endif

	

;MOV	EBX,[@RAT+0x32*8]

	MOV	[EBX + 0x94 + 0x0],EAX	;PT

	

	; clear previous stack usage 0x0

				; push the selector and the offset onto the stack

				;ACCU EA, VAL, NO ARRAY

				;Mixing_motor

	MOV	ECX,0x8c	;OFF

	MOV	EAX,0x32	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =4bytes

	PUSH	DWORD	EAX

				;Stack parameter size =8bytes

				;EFB_CALL

[EXTERN _TP_RTE]

[EXTERN _TP_OFFSET]

	XOR	EBX,EBX

	MOV	BX,_TP_RTE

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,_TP_OFFSET

	CALL	EBX

				; clean the stack

	ADD	ESP,8

					;

					;

	MOV	EBX,[@RAT+0x32*8]

	MOV	AL,[EBX + 0x98 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Q

	MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x349 + 0x0],AL	;Mixing

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x8],AL	;$LINK428

	

[GLOBAL DebugLabel3]

DebugLabel3:

					;

	MOV	EBX,[@RAT+0x32*8]

	MOV	AL,[EBX + 0x98 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Q

;MOV	EBX,[@RAT+0x32*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0xb9 + 0x0],AL	;IN

	

					;

%if 0x2ee0=0

	XOR	EAX,EAX

%else

	MOV	EAX, 0x2ee0

%endif

	

;MOV	EBX,[@RAT+0x32*8]

	MOV	[EBX + 0xbc + 0x0],EAX	;PT

	

	; clear previous stack usage 0x0

				; push the selector and the offset onto the stack

				;ACCU EA, VAL, NO ARRAY

				;TP_Mixing_done

	MOV	ECX,0xb4	;OFF

	MOV	EAX,0x32	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =4bytes

	PUSH	DWORD	EAX

				;Stack parameter size =8bytes

				;EFB_CALL

[EXTERN _TP_RTE]

[EXTERN _TP_OFFSET]

	XOR	EBX,EBX

	MOV	BX,_TP_RTE

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,_TP_OFFSET

	CALL	EBX

				; clean the stack

	ADD	ESP,8

					;

					;

	MOV	EBX,[@RAT+0x32*8]

	MOV	AL,[EBX + 0xc0 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Q

				;Unlocated unforcable

GLOBAL_LABEL65:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x346]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x346],DL	;Mixing_done

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0xc],AL	;$LINK426

	

[GLOBAL DebugLabel4]

DebugLabel4:

					;

	MOV	EBX,[@RAT+0x32*8]

	MOV	EAX,[EBX + 0xc0]

	;PhD AND	EAX,0x01	;Q

;MOV	EBX,[@RAT+0x32*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0xa5 + 0x0],AL	;IN

	

					;

%if 0x2710=0

	XOR	EAX,EAX

%else

	MOV	EAX, 0x2710

%endif

	

;MOV	EBX,[@RAT+0x32*8]

	MOV	[EBX + 0xa8 + 0x0],EAX	;PT

	

	; clear previous stack usage 0x0

				; push the selector and the offset onto the stack

				;ACCU EA, VAL, NO ARRAY

				;Refill_feeder

	MOV	ECX,0xa0	;OFF

	MOV	EAX,0x32	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =4bytes

	PUSH	DWORD	EAX

				;Stack parameter size =8bytes

				;EFB_CALL

[EXTERN _TON_RTE]

[EXTERN _TON_OFFSET]

	XOR	EBX,EBX

	MOV	BX,_TON_RTE

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,_TON_OFFSET

	CALL	EBX

				; clean the stack

	ADD	ESP,8

					;

	MOV	EBX,[@RAT+0x32*8]

	MOV	AL,[EBX + 0xac + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Q

	MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x34f + 0x0],AL	;Fill_feeder

	

[GLOBAL DebugLabel5]

DebugLabel5:

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x349 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Mixing

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x369]

	;PhD AND	EAX,0x01	;Sec

	POP	ECX

	AND	AL,CL

	

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x395 + 0x0],AL	;MixerA

	

[GLOBAL DebugLabel6]

DebugLabel6:

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x349 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Mixing

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x369]

	;PhD AND	EAX,0x01	;Sec

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x34c + 0x0],AL	;MixerB

	

			;SECTION EPIL0G with center child and not a section DFB

	XOR	EAX,EAX; 	Clear accumulator

end_section:

	PUSH	EAX

	; tree for animation link

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x336 + 0x0]

	OR	AX,AX		; Update flags for jump

	JZ	end_animation

	;proto for s_link_anim(	unsigned short sctionvar

  	;			unsigned int BP

	;			unsigned short SS)

	; push the SS segment value 0 in flat mode

	PUSH	DWORD 0x0	;Parameters are on 32bits

					;Stack parameter size =4bytes

	; push the physical stack address

	PUSH 	DWORD EBP

					;Stack parameter size =8bytes

	; here we call the animation service

	PUSH 	DWORD EAX	;Parameters are on 32bits

					;Stack parameter size =12bytes

	XOR	EBX,EBX

	; get the system call number for link animation

					;SYS_CALL

	PUSH	DWORD 0x28

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,4

	CALL	EAX

	ADD	ESP,12

end_animation:

	POP	EAX

[GLOBAL DebugLabel7]

DebugLabel7:

	LEAVE

	RET
