/*
////////////////////////////
backendResu.asm
rte/offset mode
	OS time:	16:24:20
	OS date:	04/11/19
////////////////////////////
*/
[BITS 32]

@RAT	EQU	0x04000000

OFFSET_HISTORY	EQU	0x00000000

OFFSET_DISABLE	EQU	0x00000000

NumRte0X		EQU 0x0019

NumRteLoc		EQU 0x002A

;Safe code.


[GLOBAL DebugLabel0]

DebugLabel0:			;SECTION PROLOG

	ENTER	0x1c,0

%if 0x1c>0

				;Stack cleaning

GLOBAL_LABEL81:

	XOR	EAX,EAX

	XOR	EDX,EDX

	MOV	ECX,-0x1c

Node_4_loop:

	SUB	EDX,4

	MOV	[EBP+EDX],EAX

	CMP	EDX,ECX

	JNE	Node_4_loop

%endif

[GLOBAL DebugLabel1]

DebugLabel1:

					;

	MOV	EBX,[@RAT+0x32*8]

	MOV	AL,[EBX + 0x5c + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Q

;MOV	EBX,[@RAT+0x32*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x5 + 0x0],AL	;IN

	

					;

%if 0x1f40=0

	XOR	EAX,EAX

%else

	MOV	EAX, 0x1f40

%endif

	

;MOV	EBX,[@RAT+0x32*8]

	MOV	[EBX + 0x8 + 0x0],EAX	;PT

	

	; clear previous stack usage 0x0

				; push the selector and the offset onto the stack

				;ACCU EA, VAL, NO ARRAY

				;monostable2

	MOV	ECX,0x0	;OFF

	MOV	EAX,0x32	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =4bytes

	PUSH	DWORD	EAX

				;Stack parameter size =8bytes

				;EFB_CALL

[EXTERN _TP_RTE]

[EXTERN _TP_OFFSET]

	XOR	EBX,EBX

	MOV	BX,_TP_RTE

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,_TP_OFFSET

	CALL	EBX

				; clean the stack

	ADD	ESP,8

					;

	MOV	EBX,[@RAT+0x32*8]

	MOV	AL,[EBX + 0xc + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Q

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x4],AL	;$LINK496

	

[GLOBAL DebugLabel2]

DebugLabel2:

					;

;MOV	EBX,[@RAT+0x32*8]

	MOV	AL,[EBX + 0xc + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Q

	NOT	EAX

	; AND	EAX,1 ; PhD

	

;MOV	EBX,[@RAT+0x32*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x55 + 0x0],AL	;IN

	

					;

%if 0xfa0=0

	XOR	EAX,EAX

%else

	MOV	EAX, 0xfa0

%endif

	

;MOV	EBX,[@RAT+0x32*8]

	MOV	[EBX + 0x58 + 0x0],EAX	;PT

	

	; clear previous stack usage 0x0

				; push the selector and the offset onto the stack

				;ACCU EA, VAL, NO ARRAY

				;monostable1

	MOV	ECX,0x50	;OFF

	MOV	EAX,0x32	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =4bytes

	PUSH	DWORD	EAX

				;Stack parameter size =8bytes

				;EFB_CALL

[EXTERN _TP_RTE]

[EXTERN _TP_OFFSET]

	XOR	EBX,EBX

	MOV	BX,_TP_RTE

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,_TP_OFFSET

	CALL	EBX

				; clean the stack

	ADD	ESP,8

					;

	MOV	EBX,[@RAT+0x32*8]

	MOV	AL,[EBX + 0x5c + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Q

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x8],AL	;$LINK500

	

[GLOBAL DebugLabel3]

DebugLabel3:

					;

	MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x361]

	;PhD AND	EAX,0x01	;Start_process

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	PUSH	EAX

	MOV	EBX,[@RAT+0x32*8]

	MOV	AL,[EBX + 0x5c + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Q

	POP	ECX

	OR	AL,CL

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0xc],AL	;$LINK501

	

[GLOBAL DebugLabel4]

DebugLabel4:

					;

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x342 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Material_ok

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x33f + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Temp_ok

	POP	ECX

	AND	AL,CL

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x10],AL	;$LINK499

	

[GLOBAL DebugLabel5]

DebugLabel5:

					;

	MOV	EAX, 0x1

	

	MOV	EBX,[@RAT+0x54*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x0 + 0x0],AL	;ED

	

					;

	MOV	AL,[EBP - 0x10]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK499

;MOV	EBX,[@RAT+0x54*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x1 + 0x0],AL	;start

	

					;

	MOV	AL,[EBP - 0xc]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK501

;MOV	EBX,[@RAT+0x54*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x2 + 0x0],AL	;stop

	

					;

	MOV	EAX, 0x1

	

;MOV	EBX,[@RAT+0x54*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x3 + 0x0],AL	;left_direction

	

					;

	MOV	EAX, 0x0

	

;MOV	EBX,[@RAT+0x54*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x4 + 0x0],AL	;right_direction

	

					;

	MOV	EAX, 0x0

	

;MOV	EBX,[@RAT+0x54*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x5 + 0x0],AL	;fdbk_simul

	

					; Move indirect

						;A c u EA left

[EXTERN Asp3o7$G_I_OFFSET]

	MOV	ECX,Asp3o7$G_I_OFFSET

[EXTERN Asp3o7$G_I_RTE]

	MOV	EAX,Asp3o7$G_I_RTE

						;S t o r e EA right

					;STOR EA, VAL

				;$IlGrandeMassimo

;MOV	EBX,[@RAT+0x54*8]

	MOV	[EBX + 0x54 + 0x0],EAX	;RTE

	MOV	[EBX + 0x54 + 0x0 + 4],ECX	;OFF

	; segundo_postcalled_node

	; clear previous stack usage 0x0

	PUSH DWORD 0x77

				;Stack parameter size =4bytes

				; push the selector and the offset onto the stack

				;ACCU EA, VAL, NO ARRAY

				;Forming_motor

	MOV	ECX,0x0	;OFF

	MOV	EAX,0x54	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =8bytes

	PUSH	DWORD	EAX

				;Stack parameter size =12bytes

	;DBF_CALL POSTCALLED

[EXTERN Aspfo1$X]

	XOR	EBX,EBX

	MOV	BX,Aspfo1$X

	LEA	EBX,[EBX*8+@RAT]

	CALL	NEAR [EBX]

[GLOBAL DebugLabel6]

DebugLabel6:

	NOP					;For STEP INTO and OVER

				; clean the stack

	ADD	ESP,12

					;

	MOV	EBX,[@RAT+0x54*8]

	MOV	AL,[EBX + 0x8 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;running_left

				;Unlocated unforcable

GLOBAL_LABEL82:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x460]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x460],DL	;Forming

	

					;

	MOV	EBX,[@RAT+0x54*8]

	MOV	EAX,[EBX + 0xc + 0x0]	;fdbk_et

	MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x10 + 0x0],EAX	;fdbk_ET_forming

	

[GLOBAL DebugLabel7]

DebugLabel7:

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x342 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Material_ok

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x33f + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Temp_ok

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x361]

	;PhD AND	EAX,0x01	;Start_process

	POP	ECX

	AND	AL,CL

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x14],AL	;$LINK497

	

[GLOBAL DebugLabel8]

DebugLabel8:

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x342 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Material_ok

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x33f + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Temp_ok

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x18],AL	;$LINK502

	

[GLOBAL DebugLabel9]

DebugLabel9:

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x361]

	;PhD AND	EAX,0x01	;Start_process

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	PUSH	EAX

	MOV	AL,[EBP - 0x18]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK502

	POP	ECX

	OR	AL,CL

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x1c],AL	;$LINK498

	

[GLOBAL DebugLabel10]

DebugLabel10:

					;

	MOV	EAX, 0x1

	

	MOV	EBX,[@RAT+0x56*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x0 + 0x0],AL	;ED

	

					;

	MOV	AL,[EBP - 0x14]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK497

;MOV	EBX,[@RAT+0x56*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x1 + 0x0],AL	;start

	

					;

	MOV	AL,[EBP - 0x1c]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK498

;MOV	EBX,[@RAT+0x56*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x2 + 0x0],AL	;stop

	

					;

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x368 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;test

	MOV	EBX,[@RAT+0x56*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x6 + 0x0],AL	;feedback

	

					;

	MOV	EAX, 0x1

	

;MOV	EBX,[@RAT+0x56*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x3 + 0x0],AL	;left_direction

	

					;

	MOV	EAX, 0x0

	

;MOV	EBX,[@RAT+0x56*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x4 + 0x0],AL	;right_direction

	

					;

	MOV	EAX, 0x0

	

;MOV	EBX,[@RAT+0x56*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x5 + 0x0],AL	;fdbk_simul

	

					; Move indirect

						;A c u EA left

[EXTERN Asp3o7$G_I2_OFFSET]

	MOV	ECX,Asp3o7$G_I2_OFFSET

[EXTERN Asp3o7$G_I2_RTE]

	MOV	EAX,Asp3o7$G_I2_RTE

						;S t o r e EA right

					;STOR EA, VAL

				;$IlGrandeMassimo

;MOV	EBX,[@RAT+0x56*8]

	MOV	[EBX + 0x54 + 0x0],EAX	;RTE

	MOV	[EBX + 0x54 + 0x0 + 4],ECX	;OFF

	; segundo_postcalled_node

	; clear previous stack usage 0x0

	PUSH DWORD 0x7f

				;Stack parameter size =4bytes

				; push the selector and the offset onto the stack

				;ACCU EA, VAL, NO ARRAY

				;Conveying_motor

	MOV	ECX,0x0	;OFF

	MOV	EAX,0x56	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =8bytes

	PUSH	DWORD	EAX

				;Stack parameter size =12bytes

	;DBF_CALL POSTCALLED

[EXTERN Aspfo1$X]

	XOR	EBX,EBX

	MOV	BX,Aspfo1$X

	LEA	EBX,[EBX*8+@RAT]

	CALL	NEAR [EBX]

[GLOBAL DebugLabel11]

DebugLabel11:

	NOP					;For STEP INTO and OVER

				; clean the stack

	ADD	ESP,12

					;

	MOV	EBX,[@RAT+0x56*8]

	MOV	AL,[EBX + 0x8 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;running_left

	MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x355 + 0x0],AL	;Conveying_screw

	

					;

	MOV	EBX,[@RAT+0x56*8]

	MOV	EAX,[EBX + 0xc + 0x0]	;fdbk_et

	MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x18 + 0x0],EAX	;fdbk_ET_conveyer

	

[GLOBAL DebugLabel12]

DebugLabel12:

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x355 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Conveying_screw

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x369]

	;PhD AND	EAX,0x01	;Sec

	POP	ECX

	AND	AL,CL

	

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x372 + 0x0],AL	;CS_A

	

			;SECTION EPIL0G with center child and not a section DFB

	XOR	EAX,EAX; 	Clear accumulator

end_section:

	PUSH	EAX

	; tree for animation link

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x33a + 0x0]

	OR	AX,AX		; Update flags for jump

	JZ	end_animation

	;proto for s_link_anim(	unsigned short sctionvar

  	;			unsigned int BP

	;			unsigned short SS)

	; push the SS segment value 0 in flat mode

	PUSH	DWORD 0x0	;Parameters are on 32bits

					;Stack parameter size =4bytes

	; push the physical stack address

	PUSH 	DWORD EBP

					;Stack parameter size =8bytes

	; here we call the animation service

	PUSH 	DWORD EAX	;Parameters are on 32bits

					;Stack parameter size =12bytes

	XOR	EBX,EBX

	; get the system call number for link animation

					;SYS_CALL

	PUSH	DWORD 0x28

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,4

	CALL	EAX

	ADD	ESP,12

end_animation:

	POP	EAX

[GLOBAL DebugLabel13]

DebugLabel13:

	LEAVE

	RET
