/*
////////////////////////////
backendResu.asm
rte/offset mode
	OS time:	16:24:20
	OS date:	04/11/19
////////////////////////////
*/
[BITS 32]

@RAT	EQU	0x04000000

OFFSET_HISTORY	EQU	0x00000000

OFFSET_DISABLE	EQU	0x00000000

NumRte0X		EQU 0x0019

NumRteLoc		EQU 0x002A

;Safe code.


[GLOBAL DebugLabel0]

DebugLabel0:			;SECTION PROLOG

	ENTER	0x10,0

%if 0x10>0

				;Stack cleaning

GLOBAL_LABEL83:

	XOR	EAX,EAX

	XOR	EDX,EDX

	MOV	ECX,-0x10

Node_4_loop:

	SUB	EDX,4

	MOV	[EBP+EDX],EAX

	CMP	EDX,ECX

	JNE	Node_4_loop

%endif

[GLOBAL DebugLabel1]

DebugLabel1:

					;

	MOV	EAX, 0x1

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x4],AL	;$T1

	

	MOV	ECX,1

	XOR 	EAX,EAX ; PhD added

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x56 + 0x0]	;heating_step_min_INT

	CMP	AX,0x7FFF

GLOBAL_LABEL84:

	JBE	Node_24_ok

					;Set S18

	PUSH	ECX

	PUSH	EAX

	MOV	EAX,1	;Set

	PUSH	EAX	;the system bit

	PUSH	DWORD	18	;for system bit 18

	PUSH	DWORD 24	;S_wr_sysbit

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	POP	EAX

	POP	ECX

	;Set SW125

	PUSH	ECX

	PUSH	EAX

	PUSH	DWORD	0xdef2	;the value 0xdef2

	PUSH	DWORD	125		;for system word 125

	PUSH	DWORD	26		;S_wr_sysword

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	POP	EAX

	POP	ECX

	

	XOR	ECX,ECX

	AND	EAX,0x7FFF

Node_24_ok:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x6a + 0x0],EAX	;min

	MOV	EAX,ECX	; For inlined EF with EN/ENO set ENO

	; assign eno node assoc to bool_type

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x4],AL	;$T1

					;

	MOV	AL,[EBP - 0x4]	;Byte flag

	;PhD AND	EAX,0x01	;$T1

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x8],AL	;$LINK571

	

[GLOBAL DebugLabel2]

DebugLabel2:

	MOV	AL,[EBP - 0x8]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK571

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$CondLabel1

	MOV	ECX,1

	XOR 	EAX,EAX ; PhD added

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x82 + 0x0]	;heating_step_max_INT

	CMP	AX,0x7FFF

GLOBAL_LABEL85:

	JBE	Node_52_ok

					;Set S18

	PUSH	ECX

	PUSH	EAX

	MOV	EAX,1	;Set

	PUSH	EAX	;the system bit

	PUSH	DWORD	18	;for system bit 18

	PUSH	DWORD 24	;S_wr_sysbit

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	POP	EAX

	POP	ECX

	;Set SW125

	PUSH	ECX

	PUSH	EAX

	PUSH	DWORD	0xdef2	;the value 0xdef2

	PUSH	DWORD	125		;for system word 125

	PUSH	DWORD	26		;S_wr_sysword

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	POP	EAX

	POP	ECX

	

	XOR	ECX,ECX

	AND	EAX,0x7FFF

Node_52_ok:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x6e + 0x0],EAX	;max

	MOV	EAX,ECX	; For inlined EF with EN/ENO set ENO

[GLOBAL LD_$CondLabel1]

LD_$CondLabel1:

[GLOBAL DebugLabel3]

DebugLabel3:

					;

	MOV	EAX, 0x1

	

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0xc],AL	;$T2

	

	MOV	ECX,1

	XOR 	EAX,EAX ; PhD added

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x3a + 0x0]	;cooling_step_min_INT

	CMP	AX,0x7FFF

GLOBAL_LABEL86:

	JBE	Node_74_ok

					;Set S18

	PUSH	ECX

	PUSH	EAX

	MOV	EAX,1	;Set

	PUSH	EAX	;the system bit

	PUSH	DWORD	18	;for system bit 18

	PUSH	DWORD 24	;S_wr_sysbit

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	POP	EAX

	POP	ECX

	;Set SW125

	PUSH	ECX

	PUSH	EAX

	PUSH	DWORD	0xdef2	;the value 0xdef2

	PUSH	DWORD	125		;for system word 125

	PUSH	DWORD	26		;S_wr_sysword

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	POP	EAX

	POP	ECX

	

	XOR	ECX,ECX

	AND	EAX,0x7FFF

Node_74_ok:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x5c + 0x0],EAX	;min

	MOV	EAX,ECX	; For inlined EF with EN/ENO set ENO

	; assign eno node assoc to bool_type

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0xc],AL	;$T2

					;

	MOV	AL,[EBP - 0xc]	;Byte flag

	;PhD AND	EAX,0x01	;$T2

	AND 	AL,1 ; PhD added

	MOV	[EBP - 0x10],AL	;$LINK569

	

[GLOBAL DebugLabel4]

DebugLabel4:

	MOV	AL,[EBP - 0x10]	;Byte flag

	;PhD AND	EAX,0x01	;$LINK569

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$CondLabel2

	MOV	ECX,1

	XOR 	EAX,EAX ; PhD added

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x3c + 0x0]	;cooling_step_max_INT

	CMP	AX,0x7FFF

GLOBAL_LABEL87:

	JBE	Node_102_ok

					;Set S18

	PUSH	ECX

	PUSH	EAX

	MOV	EAX,1	;Set

	PUSH	EAX	;the system bit

	PUSH	DWORD	18	;for system bit 18

	PUSH	DWORD 24	;S_wr_sysbit

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	POP	EAX

	POP	ECX

	;Set SW125

	PUSH	ECX

	PUSH	EAX

	PUSH	DWORD	0xdef2	;the value 0xdef2

	PUSH	DWORD	125		;for system word 125

	PUSH	DWORD	26		;S_wr_sysword

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	POP	EAX

	POP	ECX

	

	XOR	ECX,ECX

	AND	EAX,0x7FFF

Node_102_ok:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x60 + 0x0],EAX	;max

	MOV	EAX,ECX	; For inlined EF with EN/ENO set ENO

[GLOBAL LD_$CondLabel2]

LD_$CondLabel2:

[GLOBAL DebugLabel5]

DebugLabel5:

	MOV	ECX,1

	XOR 	EAX,EAX ; PhD added

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x80 + 0x0]	;heating_duration_int

	CMP	AX,0x7FFF

GLOBAL_LABEL88:

	JBE	Node_114_ok

					;Set S18

	PUSH	ECX

	PUSH	EAX

	MOV	EAX,1	;Set

	PUSH	EAX	;the system bit

	PUSH	DWORD	18	;for system bit 18

	PUSH	DWORD 24	;S_wr_sysbit

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	POP	EAX

	POP	ECX

	;Set SW125

	PUSH	ECX

	PUSH	EAX

	PUSH	DWORD	0xdef2	;the value 0xdef2

	PUSH	DWORD	125		;for system word 125

	PUSH	DWORD	26		;S_wr_sysword

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	POP	EAX

	POP	ECX

	

	XOR	ECX,ECX

	AND	EAX,0x7FFF

Node_114_ok:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x14 + 0x0],EAX	;heating_duration

	MOV	EAX,ECX	; For inlined EF with EN/ENO set ENO

[GLOBAL DebugLabel6]

DebugLabel6:

	MOV	ECX,1

	XOR 	EAX,EAX ; PhD added

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x64 + 0x0]	;cooling_duration_int

	CMP	AX,0x7FFF

GLOBAL_LABEL89:

	JBE	Node_124_ok

					;Set S18

	PUSH	ECX

	PUSH	EAX

	MOV	EAX,1	;Set

	PUSH	EAX	;the system bit

	PUSH	DWORD	18	;for system bit 18

	PUSH	DWORD 24	;S_wr_sysbit

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	POP	EAX

	POP	ECX

	;Set SW125

	PUSH	ECX

	PUSH	EAX

	PUSH	DWORD	0xdef2	;the value 0xdef2

	PUSH	DWORD	125		;for system word 125

	PUSH	DWORD	26		;S_wr_sysword

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	POP	EAX

	POP	ECX

	

	XOR	ECX,ECX

	AND	EAX,0x7FFF

Node_124_ok:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x0 + 0x0],EAX	;cooling_duration

	MOV	EAX,ECX	; For inlined EF with EN/ENO set ENO

			;SECTION EPIL0G with center child and not a section DFB

	XOR	EAX,EAX; 	Clear accumulator

end_section:

	PUSH	EAX

	; tree for animation link

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x332 + 0x0]

	OR	AX,AX		; Update flags for jump

	JZ	end_animation

	;proto for s_link_anim(	unsigned short sctionvar

  	;			unsigned int BP

	;			unsigned short SS)

	; push the SS segment value 0 in flat mode

	PUSH	DWORD 0x0	;Parameters are on 32bits

					;Stack parameter size =4bytes

	; push the physical stack address

	PUSH 	DWORD EBP

					;Stack parameter size =8bytes

	; here we call the animation service

	PUSH 	DWORD EAX	;Parameters are on 32bits

					;Stack parameter size =12bytes

	XOR	EBX,EBX

	; get the system call number for link animation

					;SYS_CALL

	PUSH	DWORD 0x28

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,4

	CALL	EAX

	ADD	ESP,12

end_animation:

	POP	EAX

[GLOBAL DebugLabel7]

DebugLabel7:

	LEAVE

	RET
