/*
////////////////////////////
backendResu.asm
rte/offset mode
	OS time:	16:24:19
	OS date:	04/11/19
////////////////////////////
*/
[BITS 32]

@RAT	EQU	0x04000000

OFFSET_HISTORY	EQU	0x00000000

OFFSET_DISABLE	EQU	0x00000000

NumRte0X		EQU 0x0019

NumRteLoc		EQU 0x002A

;Safe code.


[GLOBAL DebugLabel0]

DebugLabel0:				;DFB SECTION PROLOG

	ENTER 	0x0,0

%if 0x0>0

				;Stack cleaning

GLOBAL_LABEL7:

	XOR	EAX,EAX

	XOR	EDX,EDX

	MOV	ECX,-0x0

Node_4_loop:

	SUB	EDX,4

	MOV	[EBP+EDX],EAX

	CMP	EDX,ECX

	JNE	Node_4_loop

%endif

	PUSH	DWORD	EDI	;Save previous physical DFB instance

[GLOBAL DebugLabel1]

DebugLabel1:

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x6]

	;PhD AND	EAX,0x01	;start

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf1

[GLOBAL DebugLabel2]

DebugLabel2:

					;

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x0 + 0x0]	;Setpoint_temp

	MOV	EBX,EDI

	MOV	[EBX + 0x10 + 0x0],EAX	;ctemp

	

[GLOBAL LD_$labEndIf1]

LD_$labEndIf1:

[GLOBAL DebugLabel3]

DebugLabel3:

					;

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	FNCLEX

	FLD	DWORD	[ESP]

	POP	EAX

	PUSH	DWORD 0x41200000

	FSUB	DWORD [ESP]

	FSTP	DWORD [ESP]

GLOBAL_LABEL8:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	POP	EAX

	

	MOV	EBX,EDI

	MOV	[EBX + 0x18 + 0x0],EAX	;temp_1

	

[GLOBAL DebugLabel4]

DebugLabel4:

					;

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	FNCLEX

	FLD	DWORD	[ESP]

	POP	EAX

	PUSH	DWORD 0x42480000

	FSUB	DWORD [ESP]

	FSTP	DWORD [ESP]

GLOBAL_LABEL9:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	POP	EAX

	

	MOV	EBX,EDI

	MOV	[EBX + 0x1c + 0x0],EAX	;temp_2

	

[GLOBAL DebugLabel5]

DebugLabel5:

					;

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	FNCLEX

	FLD	DWORD	[ESP]

	POP	EAX

	PUSH	DWORD 0x42c80000

	FSUB	DWORD [ESP]

	FSTP	DWORD [ESP]

GLOBAL_LABEL10:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	POP	EAX

	

	MOV	EBX,EDI

	MOV	[EBX + 0x20 + 0x0],EAX	;temp_3

	

[GLOBAL DebugLabel6]

DebugLabel6:

					;

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	FNCLEX

	FLD	DWORD [ESP]

	POP	EAX

	PUSH	DWORD 0x41200000

	FADD	DWORD [ESP]

	FSTP	DWORD [ESP]

GLOBAL_LABEL11:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	POP	EAX

	

	MOV	EBX,EDI

	MOV	[EBX + 0x24 + 0x0],EAX	;temp_4

	

[GLOBAL DebugLabel7]

DebugLabel7:

					;

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	FNCLEX

	FLD	DWORD [ESP]

	POP	EAX

	PUSH	DWORD 0x42480000

	FADD	DWORD [ESP]

	FSTP	DWORD [ESP]

GLOBAL_LABEL12:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	POP	EAX

	

	MOV	EBX,EDI

	MOV	[EBX + 0x28 + 0x0],EAX	;temp_5

	

[GLOBAL DebugLabel8]

DebugLabel8:

					;

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	FNCLEX

	FLD	DWORD [ESP]

	POP	EAX

	PUSH	DWORD 0x42c80000

	FADD	DWORD [ESP]

	FSTP	DWORD [ESP]

GLOBAL_LABEL13:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	POP	EAX

	

	MOV	EBX,EDI

	MOV	[EBX + 0x2c + 0x0],EAX	;temp_6

	

[GLOBAL DebugLabel9]

DebugLabel9:

	PUSH	ESI

	MOV	EBX,EDI

	MOV	AX,[EBX + 0x4 + 0x0]	;Measured_temp

	MOV	ESI,1	; for ENO management

	CWDE		;INT_2_DINT

	PUSH	EAX

	fnclex			; clear floating point exeption

	FILD	DWORD [ESP]

GLOBAL_LABEL14:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FSTP	DWORD [ESP]

	POP	EAX

	MOV	EBX,EDI

	MOV	[EBX + 0x14 + 0x0],EAX	;ctemp2

	MOV	EAX,ESI

	POP	ESI

[GLOBAL DebugLabel10]

DebugLabel10:

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;ctemp2

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL15:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	XOR	AL,AL

	SAHF

	JP	Node_160_Undordered

	SETC	AL	;c0 inferior

Node_160_Undordered	AND	EAX,1

	PUSH	EAX

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x18 + 0x0]	;temp_1

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL16:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	AND	AX,0x0500	;c2c0

	SETZ	AL

	AND	EAX,1

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;ctemp2

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL17:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1E	;Keep underflow, overflow, zero divide, denormalized

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	AND	AX,0x4500	;Mask c3c2c0

	XOR	AX,0x4000	;/c3

	SETZ	AL

	AND	EAX,1

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x8 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;plus_5_percent

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x7 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;plus_10_percent

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labElse3

[GLOBAL DebugLabel11]

DebugLabel11:

	MOV	EAX,1

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x9 + 0x0],AL	;plus_1_percent

	JMP	LD_$labEndIf2

[GLOBAL LD_$labElse3]

LD_$labElse3:

[GLOBAL DebugLabel12]

DebugLabel12:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x9 + 0x0],AL	;plus_1_percent

	MOV	EAX,1

[GLOBAL LD_$labEndIf2]

LD_$labEndIf2:

[GLOBAL DebugLabel13]

DebugLabel13:

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;ctemp2

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL18:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	XOR	AL,AL

	SAHF

	JP	Node_234_Undordered

	SETC	AL	;c0 inferior

Node_234_Undordered	AND	EAX,1

	PUSH	EAX

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x1c + 0x0]	;temp_2

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL19:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	AND	AX,0x0500	;c2c0

	SETZ	AL

	AND	EAX,1

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;ctemp2

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x18 + 0x0]	;temp_1

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL20:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	XOR	AL,AL

	SAHF

	JP	Node_246_Undordered

	SETC	AL	;c0 inferior

Node_246_Undordered	AND	EAX,1

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;ctemp2

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x18 + 0x0]	;temp_1

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL21:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1E	;Keep underflow, overflow, zero divide, denormalized

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	AND	AX,0x4500	;Mask c3c2c0

	XOR	AX,0x4000	;/c3

	SETZ	AL

	AND	EAX,1

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

	MOV	EBX,EDI

	MOV	AL,[EBX + 0x7 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;plus_10_percent

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labElse5

[GLOBAL DebugLabel14]

DebugLabel14:

	MOV	EAX,1

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x8 + 0x0],AL	;plus_5_percent

	JMP	LD_$labEndIf4

[GLOBAL LD_$labElse5]

LD_$labElse5:

[GLOBAL DebugLabel15]

DebugLabel15:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x8 + 0x0],AL	;plus_5_percent

	MOV	EAX,1

[GLOBAL LD_$labEndIf4]

LD_$labEndIf4:

[GLOBAL DebugLabel16]

DebugLabel16:

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;ctemp2

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL22:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	XOR	AL,AL

	SAHF

	JP	Node_308_Undordered

	SETC	AL	;c0 inferior

Node_308_Undordered	AND	EAX,1

	PUSH	EAX

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x20 + 0x0]	;temp_3

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL23:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	AND	AX,0x0500	;c2c0

	SETZ	AL

	AND	EAX,1

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;ctemp2

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x1c + 0x0]	;temp_2

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL24:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	XOR	AL,AL

	SAHF

	JP	Node_320_Undordered

	SETC	AL	;c0 inferior

Node_320_Undordered	AND	EAX,1

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;ctemp2

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x1c + 0x0]	;temp_2

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL25:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1E	;Keep underflow, overflow, zero divide, denormalized

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	AND	AX,0x4500	;Mask c3c2c0

	XOR	AX,0x4000	;/c3

	SETZ	AL

	AND	EAX,1

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labElse7

[GLOBAL DebugLabel17]

DebugLabel17:

	MOV	EAX,1

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x7 + 0x0],AL	;plus_10_percent

	JMP	LD_$labEndIf6

[GLOBAL LD_$labElse7]

LD_$labElse7:

[GLOBAL DebugLabel18]

DebugLabel18:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x7 + 0x0],AL	;plus_10_percent

	MOV	EAX,1

[GLOBAL LD_$labEndIf6]

LD_$labEndIf6:

[GLOBAL DebugLabel19]

DebugLabel19:

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;ctemp2

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL26:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	AND	AX,0x4100;Equal and lower

	SETZ	AL

	AND	EAX,1

	PUSH	EAX

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x24 + 0x0]	;temp_4

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL27:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	XOR	AL,AL

	SAHF

	JP	Node_386_Unordered

	SHR	AX,8

	MOV	BX,AX

	SHR	AX,6

	XOR	AX,BX

Node_386_Unordered:

	AND	EAX,1

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;ctemp2

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL28:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1E	;Keep underflow, overflow, zero divide, denormalized

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	AND	AX,0x4500	;Mask c3c2c0

	XOR	AX,0x4000	;/c3

	SETZ	AL

	AND	EAX,1

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

	MOV	EBX,EDI

	MOV	AL,[EBX + 0xb + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;minus_5_percent

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

	MOV	EBX,EDI

	MOV	AL,[EBX + 0xc + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;minus_10_percent

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labElse9

[GLOBAL DebugLabel20]

DebugLabel20:

	MOV	EAX,1

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0xa + 0x0],AL	;minus_1_percent

	JMP	LD_$labEndIf8

[GLOBAL LD_$labElse9]

LD_$labElse9:

[GLOBAL DebugLabel21]

DebugLabel21:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0xa + 0x0],AL	;minus_1_percent

	MOV	EAX,1

[GLOBAL LD_$labEndIf8]

LD_$labEndIf8:

[GLOBAL DebugLabel22]

DebugLabel22:

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;ctemp2

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL29:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	AND	AX,0x4100;Equal and lower

	SETZ	AL

	AND	EAX,1

	PUSH	EAX

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x28 + 0x0]	;temp_5

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL30:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	XOR	AL,AL

	SAHF

	JP	Node_460_Unordered

	SHR	AX,8

	MOV	BX,AX

	SHR	AX,6

	XOR	AX,BX

Node_460_Unordered:

	AND	EAX,1

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;ctemp2

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x24 + 0x0]	;temp_4

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL31:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	AND	AX,0x4100;Equal and lower

	SETZ	AL

	AND	EAX,1

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;ctemp2

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x24 + 0x0]	;temp_4

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL32:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1E	;Keep underflow, overflow, zero divide, denormalized

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	AND	AX,0x4500	;Mask c3c2c0

	XOR	AX,0x4000	;/c3

	SETZ	AL

	AND	EAX,1

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

	MOV	EBX,EDI

	MOV	AL,[EBX + 0xc + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;minus_10_percent

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labElse11

[GLOBAL DebugLabel23]

DebugLabel23:

	MOV	EAX,1

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0xb + 0x0],AL	;minus_5_percent

	JMP	LD_$labEndIf10

[GLOBAL LD_$labElse11]

LD_$labElse11:

[GLOBAL DebugLabel24]

DebugLabel24:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0xb + 0x0],AL	;minus_5_percent

	MOV	EAX,1

[GLOBAL LD_$labEndIf10]

LD_$labEndIf10:

[GLOBAL DebugLabel25]

DebugLabel25:

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;ctemp2

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL33:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	AND	AX,0x4100;Equal and lower

	SETZ	AL

	AND	EAX,1

	PUSH	EAX

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x10 + 0x0]	;ctemp

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x2c + 0x0]	;temp_6

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL34:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	XOR	AL,AL

	SAHF

	JP	Node_534_Unordered

	SHR	AX,8

	MOV	BX,AX

	SHR	AX,6

	XOR	AX,BX

Node_534_Unordered:

	AND	EAX,1

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;ctemp2

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x28 + 0x0]	;temp_5

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL35:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	AND	AX,0x4100;Equal and lower

	SETZ	AL

	AND	EAX,1

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

	FNCLEX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x14 + 0x0]	;ctemp2

	PUSH	EAX

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x28 + 0x0]	;temp_5

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL36:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1E	;Keep underflow, overflow, zero divide, denormalized

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	AND	AX,0x4500	;Mask c3c2c0

	XOR	AX,0x4000	;/c3

	SETZ	AL

	AND	EAX,1

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labElse13

[GLOBAL DebugLabel26]

DebugLabel26:

	MOV	EAX,1

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0xc + 0x0],AL	;minus_10_percent

	JMP	LD_$labEndIf12

[GLOBAL LD_$labElse13]

LD_$labElse13:

[GLOBAL DebugLabel27]

DebugLabel27:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0xc + 0x0],AL	;minus_10_percent

	MOV	EAX,1

[GLOBAL LD_$labEndIf12]

LD_$labEndIf12:

[GLOBAL DebugLabel28]

DebugLabel28:

	MOV	EBX,EDI

	MOV	EAX,[EBX + 0x6]

	;PhD AND	EAX,0x01	;start

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf14

[GLOBAL DebugLabel29]

DebugLabel29:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0xc + 0x0],AL	;minus_10_percent

	MOV	EAX,1

[GLOBAL DebugLabel30]

DebugLabel30:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0xb + 0x0],AL	;minus_5_percent

	MOV	EAX,1

[GLOBAL DebugLabel31]

DebugLabel31:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0xa + 0x0],AL	;minus_1_percent

	MOV	EAX,1

[GLOBAL DebugLabel32]

DebugLabel32:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x7 + 0x0],AL	;plus_10_percent

	MOV	EAX,1

[GLOBAL DebugLabel33]

DebugLabel33:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x8 + 0x0],AL	;plus_5_percent

	MOV	EAX,1

[GLOBAL DebugLabel34]

DebugLabel34:

	XOR	EAX,EAX

	MOV	EBX,EDI

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x9 + 0x0],AL	;plus_1_percent

	MOV	EAX,1

[GLOBAL LD_$labEndIf14]

LD_$labEndIf14:

				; SECTION DFB EPILOG with no animation link

	XOR	EAX,EAX; Clear EAX to continue to the nexte section

end_section:

[GLOBAL DebugLabel35]

DebugLabel35:					; DFB EPIL0G

	POP	DWORD	EDI	;Restore physical DFB instance

	LEAVE

	RET
