/*
////////////////////////////
backendResu.asm
rte/offset mode
	OS time:	16:24:20
	OS date:	04/11/19
////////////////////////////
*/
[BITS 32]

@RAT	EQU	0x04000000

OFFSET_HISTORY	EQU	0x00000000

OFFSET_DISABLE	EQU	0x00000000

NumRte0X		EQU 0x0019

NumRteLoc		EQU 0x002A

;Safe code.


[GLOBAL DebugLabel1]

DebugLabel1:				;DFB SCHEDULER PROLOG

	ENTER	0x0,0

%if 0x0>0

				;Stack cleaning

GLOBAL_LABEL37:

	XOR	EAX,EAX

	XOR	EDX,EDX

	MOV	ECX,-0x0

Node_4_loop:

	SUB	EDX,4

	MOV	[EBP+EDX],EAX

	CMP	EDX,ECX

	JNE	Node_4_loop

%endif

	PUSH	DWORD	EBX

	PUSH	DWORD	ESI

	PUSH	DWORD	EDI	;Save previous physical DFB instance

	MOV	EDI,[EBP+8]	;Get RTE instance

	MOV	EDI,[@RAT+EDI*8]	;Get physical address

[GLOBAL DebugLabel2]

DebugLabel2:

						;Shedule DFB

						;Postcalled

	; clear previous stack usage 0x0

	PUSH	DWORD	[EBP+8]		;push RTE instance

					;Stack parameter size =4bytes

					;SR_CALL

[EXTERN Asp3o9$X_RTE]

[EXTERN Asp3o9$X_OFFSET]

	XOR	EBX,EBX

	MOV	BX,Asp3o9$X_RTE

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,Asp3o9$X_OFFSET

	CALL	NEAR EBX

[GLOBAL DebugLabel3]

DebugLabel3:

	NOP					;For STEP INTO and OVER

				; clean the stack

	ADD	ESP,4

	TEST	EAX,EAX		;If EAX is set a return was done

	JNZ NEAR end_section	;Jump to the end of the DFB scheduler

end_section:

[GLOBAL DebugLabel4]

DebugLabel4:					;SCHEDULER DFB EPIL0G

	POP	DWORD	EDI	;Restore physical DFB instance

	POP	DWORD	ESI

	POP	DWORD	EBX

	LEAVE

	RET 0X00
