/*
////////////////////////////
backendResu.asm
rte/offset mode
	OS time:	16:24:20
	OS date:	04/11/19
////////////////////////////
*/
[BITS 32]

@RAT	EQU	0x04000000

OFFSET_HISTORY	EQU	0x00000000

OFFSET_DISABLE	EQU	0x00000000

NumRte0X		EQU 0x0019

NumRteLoc		EQU 0x002A

;Safe code.


[GLOBAL DebugLabel0]

DebugLabel0:			;SECTION PROLOG

	ENTER	0x0,0

%if 0x0>0

				;Stack cleaning

GLOBAL_LABEL44:

	XOR	EAX,EAX

	XOR	EDX,EDX

	MOV	ECX,-0x0

Node_4_loop:

	SUB	EDX,4

	MOV	[EBP+EDX],EAX

	CMP	EDX,ECX

	JNE	Node_4_loop

%endif

[GLOBAL DebugLabel1]

DebugLabel1:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x361]	;Start_process

	AND	EAX,0x03

	CMP	EAX,0x01

	SETZ	AL

	PUSH	EAX	;Start_process

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x347]	;new_material_demand

	AND	EAX,0x03

	CMP	EAX,0x01

	SETZ	AL

	POP	ECX

	OR	AL,CL

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf1

[GLOBAL DebugLabel2]

DebugLabel2:

	MOV	EAX,1

				;Unlocated unforcable

GLOBAL_LABEL45:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x36b]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x36b],DL	;Weight_empty

[GLOBAL DebugLabel3]

DebugLabel3:

	MOV	EAX,1

				;Unlocated unforcable

GLOBAL_LABEL46:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x365]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x365],DL	;Valve_A_closed

[GLOBAL DebugLabel4]

DebugLabel4:

	MOV	EAX,1

				;Unlocated unforcable

GLOBAL_LABEL47:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x367]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x367],DL	;Valve_B_closed

[GLOBAL DebugLabel5]

DebugLabel5:

	XOR	EAX,EAX

				;Unlocated unforcable

GLOBAL_LABEL48:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x366]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x366],DL	;Valve_B_open

	MOV	EAX,1

[GLOBAL LD_$labEndIf1]

LD_$labEndIf1:

[GLOBAL DebugLabel6]

DebugLabel6:

					;

	MOV	EBX,[@RAT+0x2a*8]

	MOV	AL,[EBX + 0xa + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;%S6

				;Unlocated unforcable

GLOBAL_LABEL49:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x369]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x369],DL	;Sec

	

[GLOBAL DebugLabel7]

DebugLabel7:

					;

	MOV	EBX,[@RAT+0x2a*8]

	MOV	AL,[EBX + 0x9 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;%s5

				;Unlocated unforcable

GLOBAL_LABEL50:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x356]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x356],DL	;Ms_100

	

[GLOBAL DebugLabel8]

DebugLabel8:

					;

	MOV	EBX,[@RAT+0x2a*8]

	MOV	AL,[EBX + 0x8 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;%s4

				;Unlocated unforcable

GLOBAL_LABEL51:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x357]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x357],DL	;Ms_10

	

[GLOBAL DebugLabel9]

DebugLabel9:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x36b]	;Weight_empty

	AND	EAX,0x03

	CMP	EAX,0x01

	SETZ	AL

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf2

[GLOBAL DebugLabel10]

DebugLabel10:

	MOV	EAX,1

				;Unlocated unforcable

GLOBAL_LABEL52:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x363]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x363],DL	;Valve_A_open

[GLOBAL DebugLabel11]

DebugLabel11:

	XOR	EAX,EAX

				;Unlocated unforcable

GLOBAL_LABEL53:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x365]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x365],DL	;Valve_A_closed

	MOV	EAX,1

[GLOBAL DebugLabel12]

DebugLabel12:

	XOR	EAX,EAX

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x34b + 0x0],AL	;ready_to_mix

	MOV	EAX,1

[GLOBAL DebugLabel13]

DebugLabel13:

	XOR	EAX,EAX

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x348 + 0x0],AL	;Weighing_A_done

	MOV	EAX,1

[GLOBAL LD_$labEndIf2]

LD_$labEndIf2:

[GLOBAL DebugLabel14]

DebugLabel14:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x363]

	;PhD AND	EAX,0x01	;Valve_A_open

	PUSH	EAX	;Valve_A_open

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x369]	;Sec

	AND	EAX,0x03

	CMP	EAX,0x01

	SETZ	AL

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x28 + 0x0]	;Weighing_Material_A

;MOV	EBX,[@RAT+0x2e*8]

	CMP	AX,[EBX + 0x78 + 0x0]	;material_a_value

	SETLE	AL

	AND	EAX,1

	POP	ECX

	AND	AL,CL

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf3

[GLOBAL DebugLabel15]

DebugLabel15:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x28 + 0x0]	;Weighing_Material_A

	INC	AX

GLOBAL_LABEL54:

	JNO .no_overflow

	INTO				;Signed integer error management

	NOP

	MOV	ESI,0

.no_overflow:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x28 + 0x0],AX	;Weighing_Material_A

	; get the overflow flag

	SETNO AL

[GLOBAL DebugLabel16]

DebugLabel16:

	XOR	EAX,EAX

				;Unlocated unforcable

GLOBAL_LABEL55:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x36b]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x36b],DL	;Weight_empty

	MOV	EAX,1

[GLOBAL LD_$labEndIf3]

LD_$labEndIf3:

[GLOBAL DebugLabel17]

DebugLabel17:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x28 + 0x0]	;Weighing_Material_A

;MOV	EBX,[@RAT+0x2e*8]

	CMP	AX,[EBX + 0x78 + 0x0]	;material_a_value

	JNE NEAR	LD_$labEndIf4

[GLOBAL DebugLabel18]

DebugLabel18:

	XOR	EAX,EAX

				;Unlocated unforcable

GLOBAL_LABEL56:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x363]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x363],DL	;Valve_A_open

	MOV	EAX,1

[GLOBAL DebugLabel19]

DebugLabel19:

	MOV	EAX,1

				;Unlocated unforcable

GLOBAL_LABEL57:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x365]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x365],DL	;Valve_A_closed

[GLOBAL DebugLabel20]

DebugLabel20:

	MOV	EAX,1

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x348 + 0x0],AL	;Weighing_A_done

[GLOBAL DebugLabel21]

DebugLabel21:

					;

	MOV	EAX, 0x1

	

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x38c + 0x0],AL	;Flapp_A

	

[GLOBAL DebugLabel22]

DebugLabel22:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x38c + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Flapp_A

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf5

[GLOBAL DebugLabel23]

DebugLabel23:

					;

	MOV	AX, 0x0

	

;MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x28 + 0x0],AX	;Weighing_Material_A

	

[GLOBAL DebugLabel24]

DebugLabel24:

	MOV	EAX,1

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x345 + 0x0],AL	;Material_a_in

[GLOBAL LD_$labEndIf5]

LD_$labEndIf5:

[GLOBAL LD_$labEndIf4]

LD_$labEndIf4:

[GLOBAL DebugLabel25]

DebugLabel25:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x346]	;Mixing_done

	AND	EAX,0x03

	CMP	EAX,0x02

	SETZ	AL

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf6

[GLOBAL DebugLabel26]

DebugLabel26:

	XOR	EAX,EAX

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x345 + 0x0],AL	;Material_a_in

	MOV	EAX,1

[GLOBAL DebugLabel27]

DebugLabel27:

	XOR	EAX,EAX

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x343 + 0x0],AL	;Material_b_in

	MOV	EAX,1

[GLOBAL LD_$labEndIf6]

LD_$labEndIf6:

[GLOBAL DebugLabel28]

DebugLabel28:

					;

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x38c + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Flapp_A

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x370 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Flapp_B

	POP	ECX

	OR	AL,CL

	

	MOV	EBX,[@RAT+0x32*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x41 + 0x0],AL	;IN

	

					;

%if 0x1388=0

	XOR	EAX,EAX

%else

	MOV	EAX, 0x1388

%endif

	

;MOV	EBX,[@RAT+0x32*8]

	MOV	[EBX + 0x44 + 0x0],EAX	;PT

	

	; clear previous stack usage 0x0

				; push the selector and the offset onto the stack

				;ACCU EA, VAL, NO ARRAY

				;Flapp

	MOV	ECX,0x3c	;OFF

	MOV	EAX,0x32	;RTE

	PUSH	DWORD	ECX

				;Stack parameter size =4bytes

	PUSH	DWORD	EAX

				;Stack parameter size =8bytes

				;EFB_CALL

[EXTERN _TP_RTE]

[EXTERN _TP_OFFSET]

	XOR	EBX,EBX

	MOV	BX,_TP_RTE

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,_TP_OFFSET

	CALL	EBX

				; clean the stack

	ADD	ESP,8

					;

	MOV	EBX,[@RAT+0x32*8]

	MOV	AL,[EBX + 0x48 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Q

	MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x36c + 0x0],AL	;Flapp_open

	

[GLOBAL DebugLabel29]

DebugLabel29:			;SECTION EPILOG

end_section:

	LEAVE

	RET 0X00
