/*
////////////////////////////
backendResu.asm
rte/offset mode
	OS time:	16:24:20
	OS date:	04/11/19
////////////////////////////
*/
[BITS 32]

@RAT	EQU	0x04000000

OFFSET_HISTORY	EQU	0x00000000

OFFSET_DISABLE	EQU	0x00000000

NumRte0X		EQU 0x0019

NumRteLoc		EQU 0x002A

;Safe code.


[GLOBAL DebugLabel0]

DebugLabel0:			;SECTION PROLOG

	ENTER	0x0,0

%if 0x0>0

				;Stack cleaning

GLOBAL_LABEL58:

	XOR	EAX,EAX

	XOR	EDX,EDX

	MOV	ECX,-0x0

Node_4_loop:

	SUB	EDX,4

	MOV	[EBP+EDX],EAX

	CMP	EDX,ECX

	JNE	Node_4_loop

%endif

[GLOBAL DebugLabel1]

DebugLabel1:

	MOV	EBX,[@RAT+0x32*8]

	MOV	EAX,[EBX + 0x4c + 0x0]	;ET

	CMP	EAX,0x1388

	SETE	AL

	AND	EAX,1

	PUSH	EAX

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x370 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Flapp_B

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf1

[GLOBAL DebugLabel2]

DebugLabel2:

					;

	MOV	EAX, 0x1

	

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x36e + 0x0],AL	;Flapp_closed

	

[GLOBAL DebugLabel3]

DebugLabel3:

					;

	MOV	EAX, 0x0

	

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x38c + 0x0],AL	;Flapp_A

	

[GLOBAL DebugLabel4]

DebugLabel4:

	MOV	EAX,1

				;Unlocated unforcable

GLOBAL_LABEL59:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x366]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x366],DL	;Valve_B_open

[GLOBAL DebugLabel5]

DebugLabel5:

	XOR	EAX,EAX

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x391 + 0x0],AL	;Weighing_B_done

	MOV	EAX,1

[GLOBAL DebugLabel6]

DebugLabel6:

	XOR	EAX,EAX

				;Unlocated unforcable

GLOBAL_LABEL60:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x367]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x367],DL	;Valve_B_closed

	MOV	EAX,1

[GLOBAL LD_$labEndIf1]

LD_$labEndIf1:

[GLOBAL DebugLabel7]

DebugLabel7:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x366]

	;PhD AND	EAX,0x01	;Valve_B_open

	PUSH	EAX	;Valve_B_open

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x369]	;Sec

	AND	EAX,0x03

	CMP	EAX,0x01

	SETZ	AL

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x84 + 0x0]	;Weighing_Material_B

;MOV	EBX,[@RAT+0x2e*8]

	CMP	AX,[EBX + 0x36 + 0x0]	;material_b_value

	SETLE	AL

	AND	EAX,1

	POP	ECX

	AND	AL,CL

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf2

[GLOBAL DebugLabel8]

DebugLabel8:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x84 + 0x0]	;Weighing_Material_B

	INC	AX

GLOBAL_LABEL61:

	JNO .no_overflow

	INTO				;Signed integer error management

	NOP

	MOV	ESI,0

.no_overflow:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x84 + 0x0],AX	;Weighing_Material_B

	; get the overflow flag

	SETNO AL

[GLOBAL LD_$labEndIf2]

LD_$labEndIf2:

[GLOBAL DebugLabel9]

DebugLabel9:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x84 + 0x0]	;Weighing_Material_B

;MOV	EBX,[@RAT+0x2e*8]

	CMP	AX,[EBX + 0x36 + 0x0]	;material_b_value

	JNE NEAR	LD_$labEndIf3

[GLOBAL DebugLabel10]

DebugLabel10:

	XOR	EAX,EAX

				;Unlocated unforcable

GLOBAL_LABEL62:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x366]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x366],DL	;Valve_B_open

	MOV	EAX,1

[GLOBAL DebugLabel11]

DebugLabel11:

					;

	MOV	EAX, 0x1

	

				;Unlocated unforcable

GLOBAL_LABEL63:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x367]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x367],DL	;Valve_B_closed

	

[GLOBAL DebugLabel12]

DebugLabel12:

	MOV	EAX,1

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x391 + 0x0],AL	;Weighing_B_done

[GLOBAL DebugLabel13]

DebugLabel13:

					;

	MOV	EAX, 0x1

	

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x370 + 0x0],AL	;Flapp_B

	

[GLOBAL DebugLabel14]

DebugLabel14:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x370 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Flapp_B

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf4

[GLOBAL DebugLabel15]

DebugLabel15:

					;

	MOV	AX, 0x0

	

;MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x84 + 0x0],AX	;Weighing_Material_B

	

[GLOBAL DebugLabel16]

DebugLabel16:

	MOV	EAX,1

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x343 + 0x0],AL	;Material_b_in

[GLOBAL LD_$labEndIf4]

LD_$labEndIf4:

[GLOBAL LD_$labEndIf3]

LD_$labEndIf3:

[GLOBAL DebugLabel17]

DebugLabel17:

	MOV	EBX,[@RAT+0x32*8]

	MOV	EAX,[EBX + 0x4c + 0x0]	;ET

	CMP	EAX,0x1388

	SETE	AL

	AND	EAX,1

	PUSH	EAX

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x36c + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;Flapp_open

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf5

[GLOBAL DebugLabel18]

DebugLabel18:

					;

	MOV	EAX, 0x0

	

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x370 + 0x0],AL	;Flapp_B

	

[GLOBAL DebugLabel19]

DebugLabel19:

	MOV	EAX,1

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x34b + 0x0],AL	;ready_to_mix

[GLOBAL LD_$labEndIf5]

LD_$labEndIf5:

[GLOBAL DebugLabel20]

DebugLabel20:

					;

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x24 + 0x0]	;cv_material_A_2

;MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x74 + 0x0],AX	;Material_A

	

[GLOBAL DebugLabel21]

DebugLabel21:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x32 + 0x0]	;cv_material_B_2

	CMP	AX,0x0

	JNE NEAR	LD_$labElse7

[GLOBAL DebugLabel22]

DebugLabel22:

					;

	MOV	AX, 0x3e8

	

;MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x76 + 0x0],AX	;Material_B

	

[GLOBAL DebugLabel23]

DebugLabel23:

					;

	MOV	AX, 0x3e8

	

;MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x7c + 0x0],AX	;cv_Material_B

	

	JMP	LD_$labEndIf6

[GLOBAL LD_$labElse7]

LD_$labElse7:

[GLOBAL DebugLabel24]

DebugLabel24:

					;

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x32 + 0x0]	;cv_material_B_2

;MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x76 + 0x0],AX	;Material_B

	

[GLOBAL LD_$labEndIf6]

LD_$labEndIf6:

[GLOBAL DebugLabel25]

DebugLabel25:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x363]

	;PhD AND	EAX,0x01	;Valve_A_open

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf8

[GLOBAL DebugLabel26]

DebugLabel26:

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x7a + 0x0]	;cv_Material_A

;MOV	EBX,[@RAT+0x2e*8]

	SUB	AX,[EBX + 0x28 + 0x0]	;Weighing_Material_A

	INTO				;Signed integer error management

	NOP

	

;MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x24 + 0x0],AX	;cv_material_A_2

	

[GLOBAL LD_$labEndIf8]

LD_$labEndIf8:

[GLOBAL DebugLabel27]

DebugLabel27:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x365]

	;PhD AND	EAX,0x01	;Valve_A_closed

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf9

[GLOBAL DebugLabel28]

DebugLabel28:

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x24 + 0x0]	;cv_material_A_2

;MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x7a + 0x0],AX	;cv_Material_A

	

[GLOBAL LD_$labEndIf9]

LD_$labEndIf9:

[GLOBAL DebugLabel29]

DebugLabel29:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x366]

	;PhD AND	EAX,0x01	;Valve_B_open

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf10

[GLOBAL DebugLabel30]

DebugLabel30:

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x7c + 0x0]	;cv_Material_B

;MOV	EBX,[@RAT+0x2e*8]

	SUB	AX,[EBX + 0x84 + 0x0]	;Weighing_Material_B

	INTO				;Signed integer error management

	NOP

	

;MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x32 + 0x0],AX	;cv_material_B_2

	

[GLOBAL LD_$labEndIf10]

LD_$labEndIf10:

[GLOBAL DebugLabel31]

DebugLabel31:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x367]

	;PhD AND	EAX,0x01	;Valve_B_closed

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf11

[GLOBAL DebugLabel32]

DebugLabel32:

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x32 + 0x0]	;cv_material_B_2

;MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x7c + 0x0],AX	;cv_Material_B

	

[GLOBAL LD_$labEndIf11]

LD_$labEndIf11:

[GLOBAL DebugLabel33]

DebugLabel33:			;SECTION EPILOG

end_section:

	LEAVE

	RET 0X00
