/*
////////////////////////////
backendResu.asm
rte/offset mode
	OS time:	16:24:20
	OS date:	04/11/19
////////////////////////////
*/
[BITS 32]

@RAT	EQU	0x04000000

OFFSET_HISTORY	EQU	0x00000000

OFFSET_DISABLE	EQU	0x00000000

NumRte0X		EQU 0x0019

NumRteLoc		EQU 0x002A

;Safe code.


[GLOBAL DebugLabel0]

DebugLabel0:			;SECTION PROLOG

	ENTER	0x0,0

%if 0x0>0

				;Stack cleaning

GLOBAL_LABEL73:

	XOR	EAX,EAX

	XOR	EDX,EDX

	MOV	ECX,-0x0

Node_4_loop:

	SUB	EDX,4

	MOV	[EBP+EDX],EAX

	CMP	EDX,ECX

	JNE	Node_4_loop

%endif

[GLOBAL DebugLabel1]

DebugLabel1:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x346]	;Mixing_done

	AND	EAX,0x03

	CMP	EAX,0x02

	SETZ	AL

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf1

[GLOBAL DebugLabel2]

DebugLabel2:

					;

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x78 + 0x0]	;material_a_value

;MOV	EBX,[@RAT+0x2e*8]

	ADD	AX,[EBX + 0x36 + 0x0]	;material_b_value

	INTO				;Signed integer error management

	NOP

	

;MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x2e + 0x0],AX	;Feeder_state

	

[GLOBAL DebugLabel3]

DebugLabel3:

	XOR	EAX,EAX

				;Unlocated unforcable

GLOBAL_LABEL74:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x347]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x347],DL	;new_material_demand

	MOV	EAX,1

[GLOBAL LD_$labEndIf1]

LD_$labEndIf1:

[GLOBAL DebugLabel4]

DebugLabel4:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x460]	;Forming

	AND	EAX,0x03

	CMP	EAX,0x01

	SETZ	AL

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf2

[GLOBAL DebugLabel5]

DebugLabel5:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x2e + 0x0]	;Feeder_state

	DEC	AX

GLOBAL_LABEL75:

	JNO .no_overflow

	INTO				;Signed integer error management

	NOP

	MOV	ESI,0

.no_overflow:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x2e + 0x0],AX	;Feeder_state

	; get the overflow flag

	SETNO AL

[GLOBAL LD_$labEndIf2]

LD_$labEndIf2:

[GLOBAL DebugLabel6]

DebugLabel6:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x2e + 0x0]	;Feeder_state

	CMP	AX,0x2

	JNE NEAR	LD_$labEndIf3

[GLOBAL DebugLabel7]

DebugLabel7:

	MOV	EAX,1

				;Unlocated unforcable

GLOBAL_LABEL76:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	DH,AL	; Keep EAX for multiassign

	MOV	DL,[EBX + 0x347]

	AND	DL,0x01	; reset F and H

	SHR	DH,0x01	; Carry=ACCU

	RCL	DL,0x01	; D=Carry

	MOV	[EBX + 0x347],DL	;new_material_demand

[GLOBAL LD_$labEndIf3]

LD_$labEndIf3:

[GLOBAL DebugLabel8]

DebugLabel8:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x2e + 0x0]	;Feeder_state

	CMP	AX,0x2

	JNG NEAR	LD_$labElse5

[GLOBAL DebugLabel9]

DebugLabel9:

	MOV	EAX,1

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x340 + 0x0],AL	;feeder_full

	JMP	LD_$labEndIf4

[GLOBAL LD_$labElse5]

LD_$labElse5:

[GLOBAL DebugLabel10]

DebugLabel10:

	XOR	EAX,EAX

	MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x340 + 0x0],AL	;feeder_full

	MOV	EAX,1

[GLOBAL LD_$labEndIf4]

LD_$labEndIf4:

[GLOBAL DebugLabel11]

DebugLabel11:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x2e + 0x0]	;Feeder_state

	CMP	AX,0x2

	JNLE NEAR	LD_$labElse7

[GLOBAL DebugLabel12]

DebugLabel12:

	MOV	EAX,1

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x341 + 0x0],AL	;feeder_empty

	JMP	LD_$labEndIf6

[GLOBAL LD_$labElse7]

LD_$labElse7:

[GLOBAL DebugLabel13]

DebugLabel13:

	XOR	EAX,EAX

	MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x341 + 0x0],AL	;feeder_empty

	MOV	EAX,1

[GLOBAL LD_$labEndIf6]

LD_$labEndIf6:

[GLOBAL DebugLabel14]

DebugLabel14:

	PUSH	ESI

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x34 + 0x0]	;Measured_temp

	MOV	ESI,1	; for ENO management

	CWDE		;INT_2_DINT

	PUSH	EAX

	fnclex			; clear floating point exeption

	FILD	DWORD [ESP]

GLOBAL_LABEL77:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1F	;Keep underflow, overflow, zero divide, denormalized, invalid operation

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FSTP	DWORD [ESP]

	POP	EAX

	MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0xc + 0x0],EAX	;Cmeasured_temp

	MOV	EAX,ESI

	POP	ESI

[GLOBAL DebugLabel15]

DebugLabel15:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0xc + 0x0]	;Cmeasured_temp

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x8 + 0x0]	;Setpoint_temp

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL78:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1E	;Keep underflow, overflow, zero divide, denormalized

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNCLEX

	MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0xc + 0x0]	;Cmeasured_temp

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x8 + 0x0]	;Setpoint_temp

	PUSH	EAX

	FLD	DWORD [ESP]

	POP	ECX

	FLD	DWORD [ESP]

	POP	ECX

	FCOMPP

	

GLOBAL_LABEL79:

				;Floating error management

	PUSH	EAX

	FNSTSW	AX

	AND	AX,0x1E	;Keep underflow, overflow, zero divide, denormalized

	TEST	AX,AX

	JZ	.no_floating_error

	PUSH	EAX	;FPU status (mask 0x1F)

	PUSH	DWORD 12	;set_ffb_error_addi

[EXTERN _$P$ptr_sys_call]

	CALL	NEAR [_$P$ptr_sys_call]

	ADD	ESP,0x04	;Stack cleaning

	PUSH	DWORD 0xFFFF8ACB;E_ERR_FLOAT

	CALL	EAX

	ADD	ESP,0x08	;Stack cleaning

	XOR	ESI,ESI	;ENO=0

.no_floating_error:

	POP	EAX

		

	FNSTSW	AX

	AND	AX,0x4500	;Mask c3c2c0

	XOR	AX,0x4000	;/c3

	SETZ	AL

	AND	EAX,1

	TEST	EAX,EAX

	JE NEAR	LD_$labElse9

[GLOBAL DebugLabel16]

DebugLabel16:

					;

	MOV	EAX, 0x1

	

	MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x33f + 0x0],AL	;Temp_ok

	

	JMP	LD_$labEndIf8

[GLOBAL LD_$labElse9]

LD_$labElse9:

[GLOBAL DebugLabel17]

DebugLabel17:

					;

	MOV	EAX, 0x0

	

	MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x33f + 0x0],AL	;Temp_ok

	

[GLOBAL LD_$labEndIf8]

LD_$labEndIf8:

[GLOBAL DebugLabel18]

DebugLabel18:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x340 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;feeder_full

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x341 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;feeder_empty

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labElse11

[GLOBAL DebugLabel19]

DebugLabel19:

					;

	MOV	EAX, 0x1

	

;MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x342 + 0x0],AL	;Material_ok

	

	JMP	LD_$labEndIf10

[GLOBAL LD_$labElse11]

LD_$labElse11:

[GLOBAL DebugLabel20]

DebugLabel20:

					;

	MOV	EAX, 0x0

	

	MOV	EBX,[@RAT+0x2e*8]

	AND 	AL,1 ; PhD added

	MOV	[EBX + 0x342 + 0x0],AL	;Material_ok

	

[GLOBAL LD_$labEndIf10]

LD_$labEndIf10:

[GLOBAL DebugLabel21]

DebugLabel21:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x460]

	;PhD AND	EAX,0x01	;Forming

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AL,[EBX + 0x341 + 0x0]	;Byte flag

	;PhD AND	EAX,0x01	;feeder_empty

	NOT	EAX

	; AND	EAX,1 ; PhD

	

	POP	ECX

	AND	AL,CL

	

	PUSH	EAX

;MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x369]	;Sec

	AND	EAX,0x03

	CMP	EAX,0x01

	SETZ	AL

	POP	ECX

	AND	AL,CL

	

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf12

[GLOBAL DebugLabel22]

DebugLabel22:

;MOV	EBX,[@RAT+0x2e*8]

	MOV	AX,[EBX + 0x38 + 0x0]	;Material_in

	INC	AX

GLOBAL_LABEL80:

	JNO .no_overflow

	INTO				;Signed integer error management

	NOP

	MOV	ESI,0

.no_overflow:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x38 + 0x0],AX	;Material_in

	; get the overflow flag

	SETNO AL

[GLOBAL LD_$labEndIf12]

LD_$labEndIf12:

[GLOBAL DebugLabel23]

DebugLabel23:

	MOV	EBX,[@RAT+0x2e*8]

	MOV	EAX,[EBX + 0x460]

	;PhD AND	EAX,0x01	;Forming

	AND EAX,1 ; added by PhD otherwise test is wrong

	TEST	EAX,EAX

	JZ NEAR	LD_$labEndIf13

[GLOBAL DebugLabel24]

DebugLabel24:

					;

	MOV	AX, 0x0

	

;MOV	EBX,[@RAT+0x2e*8]

	MOV	[EBX + 0x38 + 0x0],AX	;Material_in

	

[GLOBAL LD_$labEndIf13]

LD_$labEndIf13:

[GLOBAL DebugLabel25]

DebugLabel25:			;SECTION EPILOG

end_section:

	LEAVE

	RET 0X00
