/*
////////////////////////////
backendResu.asm
rte/offset mode
	OS time:	16:24:21
	OS date:	04/11/19
////////////////////////////
*/
[BITS 32]

@RAT	EQU	0x04000000

OFFSET_HISTORY	EQU	0x00000000

OFFSET_DISABLE	EQU	0x00000000

NumRte0X		EQU 0x0019

NumRteLoc		EQU 0x002A

;Safe code.


[GLOBAL DebugLabel1]

DebugLabel1:			;DFB SCHEDULER SECTION

	ENTER	0x0,0

%if 0x0>0

				;Stack cleaning

GLOBAL_LABEL90:

	XOR	EAX,EAX

	XOR	EDX,EDX

	MOV	ECX,-0x0

Node_4_loop:

	SUB	EDX,4

	MOV	[EBP+EDX],EAX

	CMP	EDX,ECX

	JNE	Node_4_loop

%endif

	PUSH	DWORD	EBX

	PUSH	DWORD	ESI

	PUSH	DWORD	EDI

[GLOBAL DebugLabel2]

DebugLabel2:

						;Postcalled

	; clear previous stack usage 0x0

					;SR_CALL POSTCALLED

[EXTERN Asp3o1$X_RTE]

[EXTERN Asp3o1$X_OFFSET]

	XOR	EBX,EBX

	MOV	BX,Asp3o1$X_RTE

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,Asp3o1$X_OFFSET

	CALL	NEAR EBX

[GLOBAL DebugLabel3]

DebugLabel3:

	NOP					;For STEP INTO and OVER

				; clean the stack

	

[GLOBAL DebugLabel4]

DebugLabel4:

						;Postcalled

	; clear previous stack usage 0x0

					;SR_CALL POSTCALLED

[EXTERN Asp3o2$X_RTE]

[EXTERN Asp3o2$X_OFFSET]

	XOR	EBX,EBX

	MOV	BX,Asp3o2$X_RTE

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,Asp3o2$X_OFFSET

	CALL	NEAR EBX

[GLOBAL DebugLabel5]

DebugLabel5:

	NOP					;For STEP INTO and OVER

				; clean the stack

	

[GLOBAL DebugLabel6]

DebugLabel6:

						;Postcalled

	; clear previous stack usage 0x0

					;SR_CALL POSTCALLED

[EXTERN Asp3o3$X_RTE]

[EXTERN Asp3o3$X_OFFSET]

	XOR	EBX,EBX

	MOV	BX,Asp3o3$X_RTE

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,Asp3o3$X_OFFSET

	CALL	NEAR EBX

[GLOBAL DebugLabel7]

DebugLabel7:

	NOP					;For STEP INTO and OVER

				; clean the stack

	

[GLOBAL DebugLabel8]

DebugLabel8:

						;Postcalled

	; clear previous stack usage 0x0

					;SR_CALL POSTCALLED

[EXTERN Asp3o4$X_RTE]

[EXTERN Asp3o4$X_OFFSET]

	XOR	EBX,EBX

	MOV	BX,Asp3o4$X_RTE

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,Asp3o4$X_OFFSET

	CALL	NEAR EBX

[GLOBAL DebugLabel9]

DebugLabel9:

	NOP					;For STEP INTO and OVER

				; clean the stack

	

[GLOBAL DebugLabel10]

DebugLabel10:

						;Postcalled

	; clear previous stack usage 0x0

					;SR_CALL POSTCALLED

[EXTERN Asp3o5$X_RTE]

[EXTERN Asp3o5$X_OFFSET]

	XOR	EBX,EBX

	MOV	BX,Asp3o5$X_RTE

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,Asp3o5$X_OFFSET

	CALL	NEAR EBX

[GLOBAL DebugLabel11]

DebugLabel11:

	NOP					;For STEP INTO and OVER

				; clean the stack

	

[GLOBAL DebugLabel12]

DebugLabel12:

						;Postcalled

	; clear previous stack usage 0x0

					;SR_CALL POSTCALLED

[EXTERN Asp3o6$X_RTE]

[EXTERN Asp3o6$X_OFFSET]

	XOR	EBX,EBX

	MOV	BX,Asp3o6$X_RTE

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,Asp3o6$X_OFFSET

	CALL	NEAR EBX

[GLOBAL DebugLabel13]

DebugLabel13:

	NOP					;For STEP INTO and OVER

				; clean the stack

	

[GLOBAL DebugLabel14]

DebugLabel14:

						;Postcalled

	; clear previous stack usage 0x0

					;SR_CALL POSTCALLED

[EXTERN Asp3o7$X_RTE]

[EXTERN Asp3o7$X_OFFSET]

	XOR	EBX,EBX

	MOV	BX,Asp3o7$X_RTE

	MOV	EBX,[EBX*8+@RAT]

	ADD	EBX,Asp3o7$X_OFFSET

	CALL	NEAR EBX

[GLOBAL DebugLabel15]

DebugLabel15:

	NOP					;For STEP INTO and OVER

				; clean the stack

	

LD_HSB_EndSchedSection:

[GLOBAL DebugLabel16]

DebugLabel16:		; SCHEDULER EPILOG

end_section:

	POP	DWORD	EDI

	POP	DWORD	ESI

	POP	DWORD	EBX

	LEAVE

	RET
